<?php
/** Adminer Editor - Compact database editor
* @link https://www.adminer.org/
* @author Jakub Vrana, https://www.vrana.cz/
* @copyright 2009 Jakub Vrana
* @license https://www.apache.org/licenses/LICENSE-2.0 Apache License, Version 2.0
* @license https://www.gnu.org/licenses/gpl-2.0.html GNU General Public License, version 2 (one or other)
* @version 4.8.3
*/function
adminer_errors($Fb,$Gb){return!!preg_match('~^(Trying to access array offset on value of type null|Undefined array key)~',$Gb);}error_reporting(6135);set_error_handler('adminer_errors',E_WARNING);$Tb=!preg_match('~^(unsafe_raw)?$~',ini_get("filter.default"));if($Tb||ini_get("filter.default_flags")){foreach(array('_GET','_POST','_COOKIE','_SERVER')as$W){$pf=filter_input_array(constant("INPUT$W"),FILTER_UNSAFE_RAW);if($pf)$$W=$pf;}}if(function_exists("mb_internal_encoding"))mb_internal_encoding("8bit");function
connection(){global$f;return$f;}function
adminer(){global$b;return$b;}function
version(){global$ca;return$ca;}function
idf_unescape($s){if(!preg_match('~^[`\'"[]~',$s))return$s;$Qc=substr($s,-1);return
str_replace($Qc.$Qc,$Qc,substr($s,1,-1));}function
escape_string($W){return
substr(q($W),1,-1);}function
number($W){return
preg_replace('~[^0-9]+~','',$W);}function
number_type(){return'((?<!o)int(?!er)|numeric|real|float|double|decimal|money)';}function
remove_slashes($Ud,$Tb=false){if(function_exists("get_magic_quotes_gpc")&&get_magic_quotes_gpc()){while(list($w,$W)=each($Ud)){foreach($W
as$Kc=>$V){unset($Ud[$w][$Kc]);if(is_array($V)){$Ud[$w][stripslashes($Kc)]=$V;$Ud[]=&$Ud[$w][stripslashes($Kc)];}else$Ud[$w][stripslashes($Kc)]=($Tb?$V:stripslashes($V));}}}}function
bracket_escape($s,$xa=false){static$df=array(':'=>':1',']'=>':2','['=>':3','"'=>':4');return
strtr($s,($xa?array_flip($df):$df));}function
min_version($zf,$ad="",$g=null){global$f;if(!$g)$g=$f;$ve=$g->server_info;if($ad&&preg_match('~([\d.]+)-MariaDB~',$ve,$_)){$ve=$_[1];$zf=$ad;}return(version_compare($ve,$zf)>=0);}function
charset($f){return(min_version("5.5.3",0,$f)?"utf8mb4":"utf8");}function
script($Ae,$cf="\n"){return"<script".nonce().">$Ae</script>$cf";}function
script_src($uf){return"<script src='".h($uf)."'".nonce()."></script>\n";}function
nonce(){return' nonce="'.get_nonce().'"';}function
target_blank(){return' target="_blank" rel="noreferrer noopener"';}function
h($R){return
str_replace("\0","&#0;",htmlspecialchars($R,ENT_QUOTES,'utf-8'));}function
nl_br($R){return
str_replace("\n","<br>",$R);}function
checkbox($C,$X,$Ia,$Nc="",$vd="",$La="",$Oc=""){$K="<input type='checkbox' name='$C' value='".h($X)."'".($Ia?" checked":"").($Oc?" aria-labelledby='$Oc'":"").">".($vd?script("qsl('input').onclick = function () { $vd };",""):"");return($Nc!=""||$La?"<label".($La?" class='$La'":"").">$K".h($Nc)."</label>":$K);}function
optionlist($D,$oe=null,$wf=false){$K="";foreach($D
as$Kc=>$V){$_d=array($Kc=>$V);if(is_array($V)){$K.='<optgroup label="'.h($Kc).'">';$_d=$V;}foreach($_d
as$w=>$W)$K.='<option'.($wf||is_string($w)?' value="'.h($w).'"':'').(($wf||is_string($w)?(string)$w:$W)===$oe?' selected':'').'>'.h($W);if(is_array($V))$K.='</optgroup>';}return$K;}function
html_select($C,$D,$X="",$ud=true,$Oc=""){if($ud)return"<select name='".h($C)."'".($Oc?" aria-labelledby='$Oc'":"").">".optionlist($D,$X)."</select>".(is_string($ud)?script("qsl('select').onchange = function () { $ud };",""):"");$K="";foreach($D
as$w=>$W)$K.="<label><input type='radio' name='".h($C)."' value='".h($w)."'".($w==$X?" checked":"").">".h($W)."</label>";return$K;}function
select_input($c,$D,$X="",$ud="",$Md=""){$Pe=($D?"select":"input");return"<$Pe$c".($D?"><option value=''>$Md".optionlist($D,$X,true)."</select>":" size='10' value='".h($X)."' placeholder='$Md'>").($ud?script("qsl('$Pe').onchange = $ud;",""):"");}function
confirm($A="",$pe="qsl('input')"){return
script("$pe.onclick = function () { return confirm('".($A?js_escape($A):'האם אתה בטוח?')."'); };","");}function
print_fieldset($r,$Sc,$Bf=false){echo"<fieldset><legend>","<a href='#fieldset-$r'>$Sc</a>",script("qsl('a').onclick = partial(toggle, 'fieldset-$r');",""),"</legend>","<div id='fieldset-$r'".($Bf?"":" class='hidden'").">\n";}function
generate_linksbar($Wc){$Xc="<p class='links'>";foreach($Wc
as$w=>$y){if($w!==key(array_keys($Wc)))$Xc.="<span class='separator'>|</span>";$Xc.=$y;}$Xc.="</p>";return$Xc;}function
bold($Da,$La=""){return($Da?" class='active $La'":($La?" class='$La'":""));}function
odd($K=' class="odd"'){static$q=0;if(!$K)$q=-1;return($q++%2?$K:'');}function
js_escape($R){return
addcslashes($R,"\r\n'\\/");}function
json_row($w,$W=null){static$Ub=true;if($Ub)echo"{";if($w!=""){echo($Ub?"":",")."\n\t\"".addcslashes($w,"\r\n\t\"\\/").'": '.($W!==null?'"'.addcslashes($W,"\r\n\"\\/").'"':'null');$Ub=false;}else{echo"\n}\n";$Ub=true;}}function
ini_bool($Cc){$W=ini_get($Cc);return(preg_match('~^(on|true|yes)$~i',$W)||(int)$W);}function
sid(){static$K;if($K===null)$K=(SID&&!($_COOKIE&&ini_bool("session.use_cookies")));return$K;}function
set_password($Y,$O,$U,$G){$_SESSION["pwds"][$Y][$O][$U]=($_COOKIE["adminer_key"]&&is_string($G)?array(encrypt_string($G,$_COOKIE["adminer_key"])):$G);}function
get_password(){$K=get_session("pwds");if(is_array($K))$K=($_COOKIE["adminer_key"]?decrypt_string($K[0],$_COOKIE["adminer_key"]):false);return$K;}function
q($R){global$f;return$f->quote($R);}function
get_vals($I,$d=0){global$f;$K=array();$J=$f->query($I);if(is_object($J)){while($L=$J->fetch_row())$K[]=$L[$d];}return$K;}function
get_key_vals($I,$g=null,$ye=true){global$f;if(!is_object($g))$g=$f;$K=array();$J=$g->query($I);if(is_object($J)){while($L=$J->fetch_row()){if($ye)$K[$L[0]]=$L[1];else$K[]=$L[0];}}return$K;}function
get_rows($I,$g=null,$j="<p class='error'>"){global$f;$Wa=(is_object($g)?$g:$f);$K=array();$J=$Wa->query($I);if(is_object($J)){while($L=$J->fetch_assoc())$K[]=$L;}elseif(!$J&&!is_object($g)&&$j&&defined("PAGE_HEADER"))echo$j.error()."\n";return$K;}function
unique_array($L,$u){foreach($u
as$t){if(preg_match("~PRIMARY|UNIQUE~",$t["type"])){$K=array();foreach($t["columns"]as$w){if(!isset($L[$w]))continue
2;$K[$w]=$L[$w];}return$K;}}}function
escape_key($w){if(preg_match('(^([\w(]+)('.str_replace("_",".*",preg_quote(idf_escape("_"))).')([ \w)]+)$)',$w,$_))return$_[1].idf_escape(idf_unescape($_[2])).$_[3];return
idf_escape($w);}function
where($Z,$l=array()){global$f,$v;$K=array();foreach((array)$Z["where"]as$w=>$W){$w=bracket_escape($w,1);$d=escape_key($w);$K[]=$d.($v=="sql"&&is_numeric($W)&&preg_match('~\.~',$W)?" LIKE ".q($W):($v=="mssql"?" LIKE ".q(preg_replace('~[_%[]~','[\0]',$W)):" = ".unconvert_field($l[$w],q($W))));if($v=="sql"&&preg_match('~char|text~',$l[$w]["type"])&&preg_match("~[^ -@]~",$W))$K[]="$d = ".q($W)." COLLATE ".charset($f)."_bin";}foreach((array)$Z["null"]as$w)$K[]=escape_key($w)." IS NULL";return
implode(" AND ",$K);}function
where_check($W,$l=array()){parse_str($W,$Ga);remove_slashes(array(&$Ga));return
where($Ga,$l);}function
where_link($q,$d,$X,$xd="="){return"&where%5B$q%5D%5Bcol%5D=".urlencode($d)."&where%5B$q%5D%5Bop%5D=".urlencode(($X!==null?$xd:"IS NULL"))."&where%5B$q%5D%5Bval%5D=".urlencode($X);}function
convert_fields($e,$l,$N=array()){$K="";foreach($e
as$w=>$W){if($N&&!in_array(idf_escape($w),$N))continue;$sa=convert_field($l[$w]);if($sa)$K.=", $sa AS ".idf_escape($w);}return$K;}function
cookie($C,$X,$Vc=2592000){global$aa;return
header("Set-Cookie: $C=".urlencode($X).($Vc?"; expires=".gmdate("D, d M Y H:i:s",time()+$Vc)." GMT":"")."; path=".preg_replace('~\?.*~','',$_SERVER["REQUEST_URI"]).($aa?"; secure":"")."; HttpOnly; SameSite=lax",false);}function
restart_session(){if(!ini_bool("session.use_cookies"))session_start();}function
stop_session($Zb=false){$vf=ini_bool("session.use_cookies");if(!$vf||$Zb){session_write_close();if($vf&&@ini_set("session.use_cookies",false)===false)session_start();}}function&get_session($w){return$_SESSION[$w][DRIVER][SERVER][$_GET["username"]];}function
set_session($w,$W){$_SESSION[$w][DRIVER][SERVER][$_GET["username"]]=$W;}function
auth_url($Y,$O,$U,$h=null){global$sb;preg_match('~([^?]*)\??(.*)~',remove_from_uri(implode("|",array_keys($sb))."|username|".($h!==null?"db|":"").session_name()),$_);return"$_[1]?".(sid()?SID."&":"").($Y!="server"||$O!=""?urlencode($Y)."=".urlencode($O)."&":"")."username=".urlencode($U).($h!=""?"&db=".urlencode($h):"").($_[2]?"&$_[2]":"");}function
is_ajax(){return($_SERVER["HTTP_X_REQUESTED_WITH"]=="XMLHttpRequest");}function
redirect($z,$A=null){if($A!==null){restart_session();$_SESSION["messages"][preg_replace('~^[^?]*~','',($z!==null?$z:$_SERVER["REQUEST_URI"]))][]=$A;}if($z!==null){if($z=="")$z=".";header("Location: $z");exit;}}function
query_redirect($I,$z,$A,$be=true,$Kb=true,$Nb=false,$Ue=""){global$f,$j,$b;if($Kb){$De=microtime(true);$Nb=!$f->query($I);$Ue=format_time($De);}$Ce="";if($I)$Ce=$b->messageQuery($I,$Ue,$Nb);if($Nb){$j=error().$Ce.script("messagesPrint();");return
false;}if($be)redirect($z,$A.$Ce);return
true;}function
queries($I){global$f;static$H=array();static$De;if(!$De)$De=microtime(true);if($I===null)return
array(implode("\n",$H),format_time($De));$H[]=(preg_match('~;$~',$I)?"DELIMITER ;;\n$I;\nDELIMITER ":$I).";";return$f->query($I);}function
apply_queries($I,$Oe,$Hb='table'){foreach($Oe
as$S){if(!queries("$I ".$Hb($S)))return
false;}return
true;}function
queries_redirect($z,$A,$be){list($H,$Ue)=queries(null);return
query_redirect($H,$z,$A,$be,false,!$be,$Ue);}function
format_time($De){return
sprintf('%.3f s',max(0,microtime(true)-$De));}function
relative_uri(){return
str_replace(":","%3a",preg_replace('~^[^?]*/([^?]*)~','\1',$_SERVER["REQUEST_URI"]));}function
remove_from_uri($Fd=""){return
substr(preg_replace("~(?<=[?&])($Fd".(SID?"":"|".session_name()).")=[^&]*&~",'',relative_uri()."&"),0,-1);}function
pagination($F,$gb){return" ".($F==$gb?$F+1:'<a href="'.h(remove_from_uri("page").($F?"&page=$F".($_GET["next"]?"&next=".urlencode($_GET["next"]):""):"")).'">'.($F+1)."</a>");}function
get_file($w,$kb=false){$Rb=$_FILES[$w];if(!$Rb)return
null;foreach($Rb
as$w=>$W)$Rb[$w]=(array)$W;$K='';foreach($Rb["error"]as$w=>$j){if($j)return$j;$C=$Rb["name"][$w];$af=$Rb["tmp_name"][$w];$ab=file_get_contents($kb&&preg_match('~\.gz$~',$C)?"compress.zlib://$af":$af);if($kb){$De=substr($ab,0,3);if(function_exists("iconv")&&preg_match("~^\xFE\xFF|^\xFF\xFE~",$De,$ce))$ab=iconv("utf-16","utf-8",$ab);elseif($De=="\xEF\xBB\xBF")$ab=substr($ab,3);$K.=$ab."\n\n";}else$K.=$ab;}return$K;}function
upload_error($j){$fd=($j==UPLOAD_ERR_INI_SIZE?ini_get("upload_max_filesize"):0);return($j?'העלאת הקובץ נכשלה'.($fd?" ".sprintf('גודל מקסימלאי להעלאה: %sB',$fd):""):'הקובץ אינו קיים');}function
repeat_pattern($Jd,$Tc){return
str_repeat("$Jd{0,65535}",$Tc/65535)."$Jd{0,".($Tc%65535)."}";}function
is_utf8($W){return(preg_match('~~u',$W)&&!preg_match('~[\0-\x8\xB\xC\xE-\x1F]~',$W));}function
shorten_utf8($R,$Tc=80,$Ie=""){if(!preg_match("(^(".repeat_pattern("[\t\r\n -\x{10FFFF}]",$Tc).")($)?)u",$R,$_))preg_match("(^(".repeat_pattern("[\t\r\n -~]",$Tc).")($)?)",$R,$_);return
h($_[1]).$Ie.(isset($_[2])?"":"<i>…</i>");}function
format_number($W){return
strtr(number_format($W,0,".",','),preg_split('~~u','0123456789',-1,PREG_SPLIT_NO_EMPTY));}function
friendly_url($W){return
preg_replace('~[^a-z0-9_]~i','-',$W);}function
hidden_fields($Ud,$yc=array(),$Qd=''){$K=false;foreach($Ud
as$w=>$W){if(!in_array($w,$yc)){if(is_array($W))hidden_fields($W,array(),$w);else{$K=true;echo'<input type="hidden" name="'.h($Qd?$Qd."[$w]":$w).'" value="'.h($W).'">';}}}return$K;}function
hidden_fields_get(){echo(sid()?'<input type="hidden" name="'.session_name().'" value="'.h(session_id()).'">':''),(SERVER!==null?'<input type="hidden" name="'.DRIVER.'" value="'.h(SERVER).'">':""),'<input type="hidden" name="username" value="'.h($_GET["username"]).'">';}function
table_status1($S,$Ob=false){$K=table_status($S,$Ob);return($K?$K:array("Name"=>$S));}function
column_foreign_keys($S){global$b;$K=array();foreach($b->foreignKeys($S)as$dc){foreach($dc["source"]as$W)$K[$W][]=$dc;}return$K;}function
enum_input($jf,$c,$k,$X,$Bb=null){global$b;preg_match_all("~'((?:[^']|'')*)'~",$k["length"],$cd);$K=($Bb!==null?"<label><input type='$jf'$c value='$Bb'".((is_array($X)?in_array($Bb,$X):$X===0)?" checked":"")."><i>".'ריק'."</i></label>":"");foreach($cd[1]as$q=>$W){$W=stripcslashes(str_replace("''","'",$W));$Ia=(is_int($X)?$X==$q+1:(is_array($X)?in_array($q+1,$X):$X===$W));$K.=" <label><input type='$jf'$c value='".($q+1)."'".($Ia?' checked':'').'>'.h($b->editVal($W,$k)).'</label>';}return$K;}function
input($k,$X,$o){global$kf,$b,$v;$C=h(bracket_escape($k["field"]));echo"<td class='function'>";if(is_array($X)&&!$o){$qa=array($X);if(version_compare(PHP_VERSION,5.4)>=0)$qa[]=JSON_PRETTY_PRINT;$X=call_user_func_array('json_encode',$qa);$o="json";}$fe=($v=="mssql"&&$k["auto_increment"]);if($fe&&!$_POST["save"])$o=null;$ic=(isset($_GET["select"])||$fe?array("orig"=>'מקורי'):array())+$b->editFunctions($k);$c=" name='fields[$C]'";if($k["type"]=="enum")echo
h($ic[""])."<td>".$b->editInput($_GET["edit"],$k,$c,$X);else{$oc=(in_array($o,$ic)||isset($ic[$o]));echo(count($ic)>1?"<select name='function[$C]'>".optionlist($ic,$o===null||$oc?$o:"")."</select>".on_help("getTarget(event).value.replace(/^SQL\$/, '')",1).script("qsl('select').onchange = functionChange;",""):h(reset($ic))).'<td>';$Ec=$b->editInput($_GET["edit"],$k,$c,$X);if($Ec!="")echo$Ec;elseif(preg_match('~bool~',$k["type"]))echo"<input type='hidden'$c value='0'>"."<input type='checkbox'".(preg_match('~^(1|t|true|y|yes|on)$~i',$X)?" checked='checked'":"")."$c value='1'>";elseif($k["type"]=="set"){preg_match_all("~'((?:[^']|'')*)'~",$k["length"],$cd);foreach($cd[1]as$q=>$W){$W=stripcslashes(str_replace("''","'",$W));$Ia=(is_int($X)?($X>>$q)&1:in_array($W,explode(",",$X),true));echo" <label><input type='checkbox' name='fields[$C][$q]' value='".(1<<$q)."'".($Ia?' checked':'').">".h($b->editVal($W,$k)).'</label>';}}elseif(preg_match('~blob|bytea|raw|file~',$k["type"])&&ini_bool("file_uploads"))echo"<input type='file' name='fields-$C'>";elseif(($Re=preg_match('~text|lob|memo~i',$k["type"]))||preg_match("~\n~",$X)){if($Re&&$v!="sqlite")$c.=" cols='50' rows='12'";else{$M=min(12,substr_count($X,"\n")+1);$c.=" cols='30' rows='$M'".($M==1?" style='height: 1.2em;'":"");}echo"<textarea$c>".h($X).'</textarea>';}elseif($o=="json"||preg_match('~^jsonb?$~',$k["type"]))echo"<textarea$c cols='50' rows='12' class='jush-js'>".h($X).'</textarea>';else{$hd=(!preg_match('~int~',$k["type"])&&preg_match('~^(\d+)(,(\d+))?$~',$k["length"],$_)?((preg_match("~binary~",$k["type"])?2:1)*$_[1]+($_[3]?1:0)+($_[2]&&!$k["unsigned"]?1:0)):($kf[$k["type"]]?$kf[$k["type"]]+($k["unsigned"]?0:1):0));if($v=='sql'&&min_version(5.6)&&preg_match('~time~',$k["type"]))$hd+=7;echo"<input".((!$oc||$o==="")&&preg_match('~(?<!o)int(?!er)~',$k["type"])&&!preg_match('~\[\]~',$k["full_type"])?" type='number'":"")." value='".h($X)."'".($hd?" data-maxlength='$hd'":"").(preg_match('~char|binary~',$k["type"])&&$hd>20?" size='40'":"")."$c>";}echo$b->editHint($_GET["edit"],$k,$X);$Ub=0;foreach($ic
as$w=>$W){if($w===""||!$W)break;$Ub++;}if($Ub)echo
script("mixin(qsl('td'), {onchange: partial(skipOriginal, $Ub), oninput: function () { this.onchange(); }});");}}function
process_input($k){global$b,$i;$s=bracket_escape($k["field"]);$o=$_POST["function"][$s];$X=$_POST["fields"][$s];if($k["type"]=="enum"){if($X==-1)return
false;if($X=="")return"NULL";return+$X;}if($k["auto_increment"]&&$X=="")return
null;if($o=="orig")return(preg_match('~^CURRENT_TIMESTAMP~i',$k["on_update"])?idf_escape($k["field"]):false);if($o=="NULL")return"NULL";if($k["type"]=="set")return
array_sum((array)$X);if($o=="json"){$o="";$X=json_decode($X,true);if(!is_array($X))return
false;return$X;}if(preg_match('~blob|bytea|raw|file~',$k["type"])&&ini_bool("file_uploads")){$Rb=get_file("fields-$s");if(!is_string($Rb))return
false;return$i->quoteBinary($Rb);}return$b->processInput($k,$X,$o);}function
fields_from_edit(){global$i;$K=array();foreach((array)$_POST["field_keys"]as$w=>$W){if($W!=""){$W=bracket_escape($W);$_POST["function"][$W]=$_POST["field_funs"][$w];$_POST["fields"][$W]=$_POST["field_vals"][$w];}}foreach((array)$_POST["fields"]as$w=>$W){$C=bracket_escape($w,1);$K[$C]=array("field"=>$C,"privileges"=>array("insert"=>1,"update"=>1),"null"=>1,"auto_increment"=>($w==$i->primary),);}return$K;}function
search_tables(){global$b,$f;$_GET["where"][0]["val"]=$_POST["query"];$re="<ul>\n";foreach(table_status('',true)as$S=>$T){$C=$b->tableName($T);if(isset($T["Engine"])&&$C!=""&&(!$_POST["tables"]||in_array($S,$_POST["tables"]))){$J=$f->query("SELECT".limit("1 FROM ".table($S)," WHERE ".implode(" AND ",$b->selectSearchProcess(fields($S),array())),1));if(!$J||$J->fetch_row()){$Sd="<a href='".h(ME."select=".urlencode($S)."&where[0][op]=".urlencode($_GET["where"][0]["op"])."&where[0][val]=".urlencode($_GET["where"][0]["val"]))."'>$C</a>";echo"$re<li>".($J?$Sd:"<p class='error'>$Sd: ".error())."\n";$re="";}}}echo($re?"<p class='message'>".'אין טבלאות':"</ul>")."\n";}function
dump_headers($wc,$kd=false){global$b;$K=$b->dumpHeaders($wc,$kd);$Cd=$_POST["output"];if($Cd!="text")header("Content-Disposition: attachment; filename=".$b->dumpFilename($wc).".$K".($Cd!="file"&&preg_match('~^[0-9a-z]+$~',$Cd)?".$Cd":""));session_write_close();ob_flush();flush();return$K;}function
dump_csv($L){foreach($L
as$w=>$W){if(preg_match('~["\n,;\t]|^0|\.\d*0$~',$W)||$W==="")$L[$w]='"'.str_replace('"','""',$W).'"';}echo
implode(($_POST["format"]=="csv"?",":($_POST["format"]=="tsv"?"\t":";")),$L)."\r\n";}function
apply_sql_function($o,$d){return($o?($o=="unixepoch"?"DATETIME($d, '$o')":($o=="count distinct"?"COUNT(DISTINCT ":strtoupper("$o("))."$d)"):$d);}function
get_temp_dir(){$K=ini_get("upload_tmp_dir");if(!$K){if(function_exists('sys_get_temp_dir'))$K=sys_get_temp_dir();else{$m=@tempnam("","");if(!$m)return
false;$K=dirname($m);unlink($m);}}return$K;}function
file_open_lock($m){$n=@fopen($m,"r+");if(!$n){$n=@fopen($m,"w");if(!$n)return;chmod($m,0660);}flock($n,LOCK_EX);return$n;}function
file_write_unlock($n,$hb){rewind($n);fwrite($n,$hb);ftruncate($n,strlen($hb));flock($n,LOCK_UN);fclose($n);}function
password_file($cb){$m=get_temp_dir()."/adminer.key";$K=@file_get_contents($m);if($K||!$cb)return$K;$n=@fopen($m,"w");if($n){chmod($m,0660);$K=rand_string();fwrite($n,$K);fclose($n);}return$K;}function
rand_string(){return
md5(uniqid(mt_rand(),true));}function
select_value($W,$y,$k,$Se){global$b;if(is_array($W)){$K="";foreach($W
as$Kc=>$V)$K.="<tr>".($W!=array_values($W)?"<th>".h($Kc):"")."<td>".select_value($V,$y,$k,$Se);return"<table cellspacing='0'>$K</table>";}if(!$y)$y=$b->selectLink($W,$k);if($y===null){if(is_mail($W))$y="mailto:$W";if(is_url($W))$y=$W;}$K=$b->editVal($W,$k);if($K!==null){if(!is_utf8($K))$K="\0";elseif($Se!=""&&is_shortable($k))$K=shorten_utf8($K,max(0,+$Se));else$K=h($K);}return$b->selectVal($K,$y,$k,$W);}function
is_mail($zb){$ta='[-a-z0-9!#$%&\'*+/=?^_`{|}~]';$rb='[[:alnum:]](?:[-[:alnum:]]{0,61}[[:alnum:]])';$Jd="$ta+(?:\\.$ta+)*@(?:$rb?\\.)+$rb";return
is_string($zb)&&preg_match("(^$Jd(?:,\\s*$Jd)*\$)i",$zb);}function
is_url($R){return(bool)preg_match('~^
			https?://                 # scheme
			(?:
				# IPv6 in square brackets
				\[(?:
					(?:[[:xdigit:]]{1,4}:){7}[[:xdigit:]]{1,4} |             # 1:2:3:4:5:6:7:8
					(?:[[:xdigit:]]{1,4}:){1,7}: |                           # 1::                             1:2:3:4:5:6:7::
					(?:[[:xdigit:]]{1,4}:){1,6}:[[:xdigit:]]{1,4} |          # 1::8            1:2:3:4:5:6::8  1:2:3:4:5:6::8
					(?:[[:xdigit:]]{1,4}:){1,5}(?::[[:xdigit:]]{1,4}){1,2} | # 1::7:8          1:2:3:4:5::7:8  1:2:3:4:5::8
					(?:[[:xdigit:]]{1,4}:){1,4}(?::[[:xdigit:]]{1,4}){1,3} | # 1::6:7:8        1:2:3:4::6:7:8  1:2:3:4::8
					(?:[[:xdigit:]]{1,4}:){1,3}(?::[[:xdigit:]]{1,4}){1,4} | # 1::5:6:7:8      1:2:3::5:6:7:8  1:2:3::8
					(?:[[:xdigit:]]{1,4}:){1,2}(?::[[:xdigit:]]{1,4}){1,5} | # 1::4:5:6:7:8    1:2::4:5:6:7:8  1:2::8
					[[:xdigit:]]{1,4}:(?::[[:xdigit:]]{1,4}){1,6} |          # 1::3:4:5:6:7:8  1::3:4:5:6:7:8  1::8
					:(?::[[:xdigit:]]{1,4}){1,7} |                           # ::2:3:4:5:6:7:8 ::2:3:4:5:6:7:8 ::8
					fe80:(?::[[:xdigit:]]{0,4}){0,4}%[[:alnum:]]+ |          # fe80::7:8%eth0  fe80::7:8%1     (link-local IPv6 addresses with zone index)
					::(?:ffff(?::0{1,4})?:)?
						(?:(?:25[0-5]|(?:2[0-4]|1?[0-9])?[0-9])\.){3}
						(?:25[0-5]|(?:2[0-4]|1?[0-9])?[0-9])
						(?<!\b0\.0\.0\.0) |                                  # ::255.255.255.255  ::ffff:255.255.255.255 ::ffff:0:255.255.255.255  (IPv4-mapped IPv6 addresses and IPv4-translated addresses)
					(?:[[:xdigit:]]{1,4}:){1,4}:
						(?:(?:25[0-5]|(?:2[0-4]|1?[0-9])?[0-9])\.){3}
						(?:25[0-5]|(?:2[0-4]|1?[0-9])?[0-9])
						(?<!\b0\.0\.0\.0)                                    # 2001:db8:3:4::192.0.2.33  64:ff9b::192.0.2.33 (IPv4-Embedded IPv6 Address)
				)\] |
				# IPv4
				(?:(?:25[0-5]|(?:2[0-4]|1?[0-9])?[0-9])\.){3}
					(?:25[0-5]|(?:2[0-4]|1?[0-9])?[0-9])
					(?<!\b0\.0\.0\.0) |                                      # 0.0.0.0 excluded for URLs
				# domain
				[_[:alnum:]](?:[-_[:alnum:]]{0,61}[_[:alnum:]])?
					(?:\.[_[:alnum:]](?:[-_[:alnum:]]{0,61}[_[:alnum:]])?)*
			)                         # host
			(?::(?:[1-9]\d{0,3})?\d)? # port
			(?:/[^\s?\#]*)?           # path
			(?:\?[^\s\#]*)?           # query
			(?:\#\S*)?                # fragment
			$~xi',$R);}function
is_shortable($k){return
preg_match('~char|text|json|lob|geometry|point|linestring|polygon|string|bytea~',$k["type"]);}function
count_rows($S,$Z,$Ic,$p){global$v;$I=" FROM ".table($S).($Z?" WHERE ".implode(" AND ",$Z):"");return($Ic&&($v=="sql"||count($p)==1)?"SELECT COUNT(DISTINCT ".implode(", ",$p).")$I":"SELECT COUNT(*)".($Ic?" FROM (SELECT 1$I GROUP BY ".implode(", ",$p).") x":$I));}function
slow_query($I){global$b,$bf,$i;$h=$b->database();$Ve=$b->queryTimeout();$_e=$i->slowQuery($I,$Ve);if(!$_e&&support("kill")&&is_object($g=connect())&&($h==""||$g->select_db($h))){$Mc=$g->result(connection_id());echo'<script',nonce(),'>
var timeout = setTimeout(function () {
	ajax(\'',js_escape(ME),'script=kill\', function () {
	}, \'kill=',$Mc,'&token=',$bf,'\');
}, ',1000*$Ve,');
</script>
';}else$g=null;ob_flush();flush();$K=@get_key_vals(($_e?$_e:$I),$g,false);if($g){echo
script("clearTimeout(timeout);");ob_flush();flush();}return$K;}function
get_token(){$Zd=rand(1,1e6);return($Zd^$_SESSION["token"]).":$Zd";}function
verify_token(){list($bf,$Zd)=explode(":",$_POST["token"]);return($Zd^$_SESSION["token"])==$bf;}function
lzw_decompress($Ba){$pb=256;$Ca=8;$Na=array();$ge=0;$he=0;for($q=0;$q<strlen($Ba);$q++){$ge=($ge<<8)+ord($Ba[$q]);$he+=8;if($he>=$Ca){$he-=$Ca;$Na[]=$ge>>$he;$ge&=(1<<$he)-1;$pb++;if($pb>>$Ca)$Ca++;}}$ob=range("\0","\xFF");$K="";foreach($Na
as$q=>$Ma){$yb=$ob[$Ma];if(!isset($yb))$yb=$Ff.$Ff[0];$K.=$yb;if($q)$ob[]=$Ff.$yb[0];$Ff=$yb;}return$K;}function
on_help($Sa,$ze=0){return
script("mixin(qsl('select, input'), {onmouseover: function (event) { helpMouseover.call(this, event, $Sa, $ze) }, onmouseout: helpMouseout});","");}function
edit_form($S,$l,$L,$sf){global$b,$v,$bf,$j;$Me=$b->tableName(table_status1($S,true));page_header(($sf?'ערוך':'הכנס'),$j,array("select"=>array($S,$Me)),$Me);$b->editRowPrint($S,$l,$L,$sf);if($L===false)echo"<p class='error'>".'אין שורות'."\n";echo'<form action="" method="post" enctype="multipart/form-data" id="form">
';if(!$l)echo"<p class='error'>".'אין לך ההרשאות המתאימות לעדכן טבלה זו'."\n";else{echo"<table cellspacing='0' class='layout'>".script("qsl('table').onkeydown = editingKeydown;");foreach($l
as$C=>$k){echo"<tr><th>".$b->fieldName($k);$lb=$_GET["set"][bracket_escape($C)];if($lb===null){$lb=$k["default"];if($k["type"]=="bit"&&preg_match("~^b'([01]*)'\$~",$lb,$ce))$lb=$ce[1];}$X=($L!==null?($L[$C]!=""&&$v=="sql"&&preg_match("~enum|set~",$k["type"])?(is_array($L[$C])?array_sum($L[$C]):+$L[$C]):(is_bool($L[$C])?+$L[$C]:$L[$C])):(!$sf&&$k["auto_increment"]?"":(isset($_GET["select"])?false:$lb)));if(!$_POST["save"]&&is_string($X))$X=$b->editVal($X,$k);$o=($_POST["save"]?(string)$_POST["function"][$C]:($sf&&preg_match('~^CURRENT_TIMESTAMP~i',$k["on_update"])?"now":($X===false?null:($X!==null?'':'NULL'))));if(!$_POST&&!$sf&&$X==$k["default"]&&preg_match('~^[\w.]+\(~',$X))$o="SQL";if(preg_match("~time~",$k["type"])&&preg_match('~^CURRENT_TIMESTAMP~i',$X)){$X="";$o="now";}input($k,$X,$o);echo"\n";}if(!support("table"))echo"<tr>"."<th><input name='field_keys[]'>".script("qsl('input').oninput = fieldChange;")."<td class='function'>".html_select("field_funs[]",$b->editFunctions(array("null"=>isset($_GET["select"]))))."<td><input name='field_vals[]'>"."\n";echo"</table>\n";}echo"<p>\n";if($l){echo"<input type='submit' value='".'שמור'."'>\n";if(!isset($_GET["select"])){echo"<input type='submit' name='insert' value='".($sf?'שמור והמשך לערוך':'שמור והמשך להכניס')."' title='Ctrl+Shift+Enter'>\n",($sf?script("qsl('input').onclick = function () { return !ajaxForm(this.form, '".'שומר'."…', this); };"):"");}}echo($sf?"<input type='submit' name='delete' value='".'מחק'."'>".confirm()."\n":($_POST||!$l?"":script("focus(qsa('td', qs('#form'))[1].firstChild);")));if(isset($_GET["select"]))hidden_fields(array("check"=>(array)$_POST["check"],"clone"=>$_POST["clone"],"all"=>$_POST["all"]));echo'<input type="hidden" name="referer" value="',h(isset($_POST["referer"])?$_POST["referer"]:$_SERVER["HTTP_REFERER"]),'">
<input type="hidden" name="save" value="1">
<input type="hidden" name="token" value="',$bf,'">
</form>
';}if(isset($_GET["file"])){if($_SERVER["HTTP_IF_MODIFIED_SINCE"]){header("HTTP/1.1 304 Not Modified");exit;}header("Expires: ".gmdate("D, d M Y H:i:s",time()+365*24*60*60)." GMT");header("Last-Modified: ".gmdate("D, d M Y H:i:s")." GMT");header("Cache-Control: immutable");if($_GET["file"]=="favicon.ico"){header("Content-Type: image/x-icon");echo
lzw_decompress("\0\0\0` \0(\0Z\n|\"ј^=HdR9\$M'J\$hV-9K%\0	)NgS}?P@`:^\\2-K T*VWVdRDM=e	{F-KMjo\\hRD/~%kd^V.KR՝݂bqX9/c\neԳ4B\0=&G/K3/5XX4۽^UإaDTegeKާVu/6ߒT{ը@r>	/]b\0VܼOsrJ@b^>>aiP\nN%^q%	xx)\n:bAaC*T0ic)b'x	y,AhGX%*ZS<.T/j^kH)x_'xԗP/.\nBiy#F)7@I`*iy7Saʗ\"\0HIDu%t{%K'xiL9(%_A:4UH-G/X_<W=ixO@B;|u\n^`6:^t%\"^襏`?%\0\0-Zȥ@!L)at\n\r◎iyҗbX?xPix|d%JX>p(s2(^^'^dB*NXvj~@@y_pI\"_I%nI|J^\"cgahsR^;IxƔu*^o%vy%:XJ+Ua%pI2^C%z_>id[%Jn,wؖc;^h%p?y/aq[k\r}O%֋tXإ8z;8k֏i`9֒+.Ic&*^IvZp	ljdKKJ%HX!88@f`I`%QrX-G\0K	//BXyD\0ļ_?<'!X\"/H֒˔:\r\$v\$j'KǢ,İ)\0Zhh5KG&aKɉ,a<BAIxu%ᄗH8-E bI`%_d\0-JZ,\nT,wK:Z7)I:K|2XSD%Uʠ[+iҺX_ R^q/%\$0DDV;AhF҉6r0-h0fݛ⬗^RA/\n~pVKLSzlCq/\n~?/3B|\$TI%qIccŻ\"Bg&BX.y,ld\$K-nhNK(I9|ؗ^(!}.EgBV-+<Y9R\\uULh,dRIxf-焺4K]\nPRi,?9+,fN*w@Z HhV\"F`k\$w\\-sBY\0Du5`	*ig8_E!ơL<`ΝD%HlEQ!:\r~?\$K7D!q`5XUwIІ	xsA<Ka/ʖ@q-P^Wk-@b\"B/\0Q󰚨}y,dKp-.e1s	.%]0jjKA/1H2_\"kۛ3n&3`ضA(3	`,Hۡ%LxiG>u\\-6,6Mz\\Ϝ\r\$(-q#	2<EAhKjıȢ.	\$^rxx-+:X-Zw<O1.Ue(-?/0ZۏDpjZ^ZZDf݌GxA,_L ZAhYSУDK+TYYkt2p&_`57lS\"K,Ǆ#ɛsT\"5 Ak#ƣxľЙxn@`(/`Lܨn \$Kf,IUV߬藊_KDŦİ=B_AAWN,`vnKT8v^xiSvßjk%̡SZ&z}if=_\"\r!@^gAyoM]-_?ZwZKZﻞ̒|?Cx\0\0@?<x?\0?|p?CX//o`~\0!p0~>Ͻ}]/\0!'kj\0k		p	\"j|\0\0a\0/x\r o/!#\0q*Oo|\0\0\0P\0\0\0a\0a|");}elseif($_GET["file"]=="default.css"){header("Content-Type: text/css; charset=utf-8");echo
lzw_decompress("\nCo6C(\"#Ha1#yd1٘n:#(b.\rDc)a7Elñi1Ύs54f4ngsIhMдi:`,]YtL0hD*B0\rF&3xs'[Ʉtv4S%0XLW5)Yf\r^=~9g0\\@rQNn^yNj{opC%ʋGSZh5Z|>:'b{J)Ɠєt1*uS=^2*8t(0R,8j:x@9\n@1\nJ#4BRJFƋ>#J`HaahbC0\r4Ar&\nB54\$>+QA2DoMEL\"48=s5DLW7JGf**HjEK16ڸ,oLtJA\\\$Q|9-H@0\nxtV(o.+ܮ;1D8e*c\rT䍣B2܍z\n83=Ktƻu(kmׅ.G;+:2)cn<s5:6\nԡ)_\\6YL\"VV`c\$L;k&\$?XAWU48	Bޡڮz*[O24<?{36%;VV:\\A䎈	xnpxF<[xoW.U[Ãsd7rF&	bÒ]t*7ji=dZֹYy4:ieup\\6bHCxf׳Ɓ䎁sr8KrJp\$|;-9(?O2zĐߋO~o(;{]d%&Dy8EaM&\\ta<\0A8s@NC@(Y=OйҞB6x1]k44\"b(`A;8c<eBw*\\B٢0\n0 /ll˩\rC_*2~X-I\\ybfe@`u\"̆5hs@T;>Cphk%'\$ᰂI;R|`]FB\n.[r2/`\rҢ\rCKeF2[r%)Y,5&ڸpMe=(N@+9e8fnu:܋T}ԎGC\rNsg%>ÔP6Hʒl?τ_>hee,3F n9eFhaM),_#a-HiB-(vb&rJ1HhUiy\0#SM˵IS`-MTV}\"UH,  #ֵֹ;-\"ы\rt2\nFLؖu-5S_+y50Q/3E|%}AC&tGk2JiokbHjQQ\"x_B<A8'ṋbVx[\0:(ڃp)Nag(6#@d8w?l.H9ޫF~!%D-&geaZrr̆%aPMV>mq\r1P	ę-tZ :lx5&PZ6pfDg)pPLA,\\\rȮ7j1Hۿ.r&AdDHJTlɆJ @8\nI)Yf`<]fJ@8kW1v3\$k\$3v8:{}r.IiJ,nR@ٔ^AyeUpҢ:ӇkZV9[zP@{T;VA>Y=e97m^6[D\rDAp@[:*ee;pVi@!0` pN`	mnPh8^g0e/*伟Y(h.<@Pxx\0dt1\0r6ӈpPt<@~34a|{ \0mT]ht dA.1j7 RWwQ nEȾ eK`xSz׋%tb\rh3@ӹފ\r2\$0o04\0xԌ\r</`<Ex_<P1\r%up0-n!0PtPa>}`fzw@RWgZ#x6x-bdrOvin0\$&\0`P\\J& @&Nid%΄/bdmqrnE\r8d\\/\0N.\r^O@n,#D 褗	@0o\n\"^/lrc\0D/IPȭpc\00NP\n	`[oNE\rn@pfnP΀AoF2(l@VP(nI`bd pn0XHPhOOxbaϳ(znQΊΐ	`fd^%P\0dp/(x`BQ^@09^[ȯVo\"O@0. 2%V\0 jrR?.CΖ=\"W^P\rFe\$\"c nxQ\$Q nO@z `D1y	c%`nP,,`pqPRzz02D.Nio#+0X iI1Բ1grDD1)1np\"WҗΒ^\\@\r؄\0JdrV#ζ(@^>Sc6`N3x|jp?vCs\r~1epNn\r/Ai#L98%@1@O8<\$ҿ3Z;OOE@<3!Om/ M0&AlEo\"\0@%#6E50L;&6\r@*ToA3p>^`pR\0#'tT@b\"TJBhp\\SG+@Ps?C<%<E\$&:dFo@O	/#D\"aQ5Q;\0003CP\$ba-p[.	ogCDU΃1UR%Vn\"HnoDe:ϿCRR5wRuLfq_SOaNyO8R@=.uQ(/Bdi u\\OH\nZC{Ok	o[1!Pҭ&QQ4/^P+lP\n-`r,V2zr;U\npA4=W^2NdP,!PP	,Oi`cT^ҽ!UND_pHnS^TPHlϠSum1EbhQ01	 b!. PA*qQSϧ\\5M]kQ`Rq[nXQRLWc	1pȠkd@i̏qEOL#mUownqO4OC\0qc_yNpj\r1Ѝfe\npWw(N-z5<no.uIuwWh`cuhwIv\0nRC6t\nr?2hfO7jcir\"rou1*хg7\r0BbROuqV6o'e2&X{ϥЩq%0\0gzc{3`\r3e6m:suMM\rHI\0Is99:Ss:{A9z8G4v\0O;ύط/It\"/{uO{V;W\$KttP\0j)eEFyq}ؽB?)3gnt5,9CMZy&u- WwqaE.jFNN`ېpp@gvY&Y_DUU9}P=IYyI` D\"؊\0*PS(``JXb^KY>0y\r9>43++-Q5hԎK3ICGm>CL7-ۺt]\rխ.V-ۦmC\0N*; vu XB`zNn`ɝD\0V7\nplERVc9.HN.Rp@D#;:Zӱ>L:\"bZ9:;#:q;x㫧x[Jy?{%'4\$@Qn\0xɶ[Xǵ\r/sidC\rnƗew[ivQ{{K`,q=N;zѾՙ;0 m[9O@Gp\0pF3b#Bq\0dbKGH]b-ݥ_ĪI-yţM܃!Z:LZߺ.)BխZ߮A-Xi\n)|ǰmSAHMAr%03}E8;T\\\0G[S{<_ϻbi΁;wA _\0uo,I/-Aw]OĆDuqn&O-e`E}\0PCj\r}iqSRf(DD|/\"zN?\$\rd5=ĚogmMŧ2MhHFi	cNC\$_nEztꜗɺɬZ:׮O9^'˜ ;	<ͭ.jsfg|ϲT\rл'/<6}2Y]8ka\"?;]m[p+>;+9N[6QosnH;ǹϰH>;	uu}Le껢d/,/#\r1I>{_[˿\0=PFlHxWt1(RerVJ,*T?'Rp\0?2L`'p_e@u9#|?F>ɴv<zRS?d6@'i̾O\0F.B׾UM䐨pj]\r42mF4Aq&`01|cgߒ剸\0jIz_셧oN.VAl\0XkfFSKMPlF\ru\r.L>hCCIW&?+F2Q	JPVX	d\$9pv\n& 5V\"؟ð8\$*iEf,g,5DS\rh<%\raM	*MI/vg?ph`RQrľB:hY2e\nbp\0y4ZN\0T|}Gn8iHv5܎*0{ɨ0}\\%OAnS\raL4Ɏ=j՗9 Ok|-ixkܮ嶹H.\\kXa`Y\noSS7Ms`N-0琅=)o;mK:!箊z\"&Q\"6ҍgZ;֛w\n%͊o\0ٖ\$3LD\rOu%-ΊX\$)Mo\"Xܣ\\12*l.n6yI[y\"\$.%g:<M!b'ۋsޮ\n&\r҉l]b>\rCo\\!\"7AZQg)c&pFZ2'f21lP\rrP0\nhR}F6AM\0007mwjᑖƉD58 X2/#c@%ذq_cHf\0*,u> ;îx\0xP'X 1\0?G|\rqd+q(xC~S8\"B~p	efm`)Q*=!!bP[QSFr\0\"\r|AhXM\"(@*;m(dz+x}y\00022vd\0\"IGd&h*cfH-M!EH1ےđc[Ry'	NQ\\@<`\$");}elseif($_GET["file"]=="functions.js"){header("Content-Type: text/javascript; charset=utf-8");echo
lzw_decompress("\nB9 3NG89e6Ms@sLgCy '#	.t9MxC#d4Ebef0MC9=7γrNFm8Dx(u7F&(Cq`d:OAH\n*AχE*)NSR;AP 6a0A#M	4k7֧\nF7iuuU)~tNf̝+mnw[\$#(Սu^ƩNeq]\rhb.886\r\nBiZ	RY	6Acv*K'\r4b,K#9{\"=Kñ,[Ǻ= ( \n:K\r(@7H]-䘅R.tk2L#2DaOֺ8P3\rR3a\09\$\\0<r6-t91@b/2E,3JTu-N?Q[M>,ܪJ:Ot1R3SR\"#D*5ʹ_;z]=3c-C݃EFsmH\r0=>3t~<u;O6-MTUPE7lk__8'\$gX7ݍXHV}Ø4ꣾ61j(9\rxީV7 1\rONjFJ6#Udj9ci_{LXʋ%H˳`H鰋{pZ`˼J2Q;R68@!b68\n\\b-Cx6d^@@,s	(ʶCćH^B}d<}\"*0Z\"P.N|M_cHJwwlAϟ  OT\r3Hb\r):.>Qк0ʺB#.Ui爍޸#+/0zy;qI￠NAD7@VFaegkLǮSWQZ=a5B_\n6#\rg8(	ox<hd!X16/M@\\Uΐ!DIj]_zb]MLGw	٤z)g\"♝\n1b\"ӇkLr.t.bOcXw*T)Nh:tm/吿\"DiRU1#!]/dnc5ҍ#T\$8esMϧeMyaͳBp`E%F0[+%+K:HƎ'd\nYK\\XSd\$V=5FFI]\rT[#`ɔ2&x\r˕M4FTM?/d\rHZwJ2pp\r0&\$q%\0&x\"Z: EPM\$cEOH2#EKMiV)q\\%'QFV\$#P(^ѩyGT;)<OA@.`Fݥ\0000yZE,N	\\SPnhg{]kxCPa\0qJp?LmZJ:]IN	^^0pUpfIf7&Hdl6@QKR@}[e˛&1ѭLTthV@-(cv1QD\\D5'XbؤԹ*\"(أRa+5D*: JCA`Yw%E^|h蓴]%R;KAZA\\S\".XldKÍEA72\\^-Aّ0\n~=APAB='8^zPJpR	-'\r4#-B\n..\$3^>1K<@ŪOgӄkO.>ݖ*4&-XPP\"Lju\$ek]\\:5k^ל_CeqdM\rω *ry̭+g6k.k׻L_HׯPRc[Yr-\\]~C&\\зx@''ogb0( 	j\0o2A	d޵gY\nX\\@	LaJf\"ido;pu#44pÙBfWLb]Hd#@t\rS٫^%@'	~\$>ט^sp!rd`@9m?^uOS	qx0CZnc(!)̠..:\0<\0҅lp(\"@?IR\r VkNn`~#\r,X`@`kL!*d`~<\n npm.A@\$ҰmiǪ)l9lOZ!	.tL,'%:f\\0(P)p&4?2\r7weRvM`@ׯ6pLOpzQCPQ`nnq\rJg	di\0(v`zQ,\rpxLJi]\0;A^Opx(E!Z(&0*#yi%yQ>\0,.\",ާ:rlNpOo/<¥8wFo&1^\0AFC	ʓ\nP[bސ-hK#p[.p|<gjl1h^`ڹLpmPQpvmn\"?2\0^:fD*FIro̑P_\0tD!'iuo\"u瑐6\0l2\"g`mQ-Y<b,,z}(\0\rgL|\r@23):F\r-4r\0. ևSH*گa+ŲH9W\\F`AH#V҅e6 \nh&\"nS@nS=&q @3ڷkPۨ+Bft x 08.@NJJӋ H7'\$ZQ\0Bw\0^qP\rW8lJ(`DMQڷ|S1\r!G\\ĳ8N-*Q/  AD3+ w4J.?^f`A\0&\n1!*_ b0frDD\0^R}(؅`qKe4,!ML\rKr\rN2m(P0g`JĽAķ|'#_i,E,2%жCr5JtT\"T,+GsD)wGpˤu@m\0CS578@4U5S_K]XR][HuZU /%~7PT0\nFly4`mfLCZuSt'ѯRQ(o]E?0S5[>Ս_VptA150*?T3)beh~<I=cnBj Ġ\0,#d8S(CgD>DԷvg]VZF?JCc,K\">1܍B76]/i ,[/pOxڨw/|Qc^yBUD}L~gphEzlVVe@M4E{n.<:1\0D3\ryjiWKu7V6_t9eMtB܊Lɀd\0Mb\n:7;&W|Sb3GL\nh\"nr8|28\"]Ђ̔7BAkimG}~\0*\0-Xe{<b	Q֘))U'k逫>MT?ψM}J?nȏ6Bn)	\$,.EAVJvWt/<00F '>8]G£	~ DxD}	j?x< b<\$¢EXرiqحʵw:	TMO5F0e9xnFr	j}#@OpV4b!j8gCo:u~x9@\nJߒK{Jm;E3Cx\"Rte5nָ%ԯ/!GtE}K-2%i/L=/G+Cqr}&0Xٶ#r)6yj Z@P`^}*9,͢?9Q-'e3'2\r2ѱر6!≤gYhuabot	Tm4CRWa?ڋ]8O9cLCHM,Z`*J`#F A!**0I~\"MYt\"F2ѕ\$a]Za62ѮJ\rzbu\rеbupWw{`e,l˄Eytuh>S\"h*5C! à;695q9l;z9h1b4Hē_lU\nXFg(N)rG	h0'W%{j(s;u{P\rd#Yzz\$<OBf``.\$ZǤ2z5R#rHCv, |/{Kڧk>Xh;yĠ\"#n,if\r\nHKٻ\0{6({\ny|\nn\nh_v\"Gpb{N0άA-,p_c+ygh?gyY1]BeUHtGdf|(3\\v\\@h|L|m\",pT<ZqJ`EfZ\0P\0ڋvoZ\0y73_宀´VdDE3E{;<'Ez+\\îBJGSIR5wUZ:ZF;Nb쵽8e`A=4n>Fvwn4-`E]Z#)w?qo\0A߮-;2pt ;\rB68#O<0S ӽ0X{1f \\\rOD\r\0*×\"?z=:aZ;\$)ɱ\"~m3H?>47 an*]De{Ȼwnt44Y0fL=Pe)MFaӔ7|]<\"UR\$KIܐm[T3Sog9Z72Z羋mT/1N~}T=)h{^}Q_70_;&v\rk(\r\"\"iq\n>`vL  ]xFDЃ#kA<֝H-Zt@q>*x8\n@qEDy#]:)xߊBƶ#&S짪xq~tre{v+zƕ퍰\$&P[`aOw}{-K֠~Z%Ms^v셌Pe^AܲG]JNuh=GE:AȌ|(>=ICQnb漥:/f(\nQA1ra\"n=P]2#>.t\n߲Ћ;Q\"{aSf1R_T-g8ErD30_ǜU*lܵbf6h姇*[K48ixd\$\0k?[	CϘ.Ú,eH9-X֠a	b=P~\0Xz~h 6FxLm ,CN<Br8;Dm3ILHaE @LVat j\$LH sBb&_(!\0>)Ǣ\"H&VH!QH~J@(@<M l͗q\nd]\0	|oP	5(6hp2P9	\nuJ'A\rƃJw>5i1ёìeVN1uf5(HFXku(3F09Ylb(C\\,/قS^+1	?s6\"͢orJZ6&,\"%QJ;IQ4<#n>\n_)r!¥js\0P7,HS\\o{\0Gjl1HqA4\"WXC#`CI 	BE8ڝ:±/a! `Yx(]K<ID0Ex8v!灬+igJ6ZBBcBrJȆDh>#dQ	H*D\0 J\$ PXB7%Sb\nzL@e 6=p&idU\$\"@*@~dtsW6+%H\\/ZHs9hr:C%6H.%va6(p>!\"RdEF>QCeS(YKxt)Y[>ZD.|I{m(\\ +\"ȆD\nIe1aP`b#@	Sp\"u0s2 -\"`tC\nzN\\bvSh| \0-'D\"2dIwzXl-2W!vy!p\\Y͈	F[)ȀSmɖ6dа  >YDT)i[SA]d&C3g(+!\\r&STEZRFeH,JyUJ/Q++A,W\$d7P!2XNX%2	i`]r\\̵53VEKo=\n*\0J N6i~_\$:wa8³Ah9XX ǹl&e2G/񻐾Ip叉;'7S>|f(XRC!&99˫.w	Nn|8(Y\"G1!8?CH Y]U<@!u:~gYdWf	o}G~#8SnIF#\"90>X\\TGsR~Xb> ϊ8ʨ@4)Pihv\"B5\$,h3!#>MlCO@(\$qy¢f%V\nѷR>c\0Rh{(C\$!(d{cn\$WЊa`jx0D OxC1T5_<.sҐeSϞ}|p.\n?r\\Te- gBJjKpyLP4\0`P\0S[Q9FReN6צe!'gy,1>3a>f0H!(~\0B!*hǚ1&xԆż1{x]0ՑM\"]L`7SYS5/BULߣ'iA\nY}S*FBgzY@\$g\r)X\ncu<.Q̂DQq2K\n:ZtUţq<	2Ub\"5??-Apޛ2lڇA;Z-*@\0)wڳ]BgkNwȽȾ&9!\nEꦘ@U\rfRj] 3`	Q\$s6̷1sZa#&T,`	Z^M`9cTظW!BA3x{\0wl 4!}A\\к!LH&!F%3b;tT\nt0Y4]'{7p.U-39\$oj+y7nyL|c8\nLdJ`oUuv6ܳ0ZhAIO#(r/2NʮDYYWqYP`X`u0c'm\n9]k]mm%{2Yp]lfume,=k9&FyN,GYP\noOT/Md}5L`ZCDj`)a(P1K⎦S̸Q'a/	U{Qi˱<MX#Xrck	Z01X<P	)}!yte\"k ~W4Xvͱtv'*պaU}ckYVZ=̠l1lDL/L،z^a-Cc.~0^b_{F:}H\\[:) 2t`ha71I֖PZefmBT^,2Y	`hqsg1>Mpsє1>%GnzyN紳e-SYۄIHYͮǹWka iAsD5|=Bȅ{4H<FPh/Vnc˪ɣ=`xOϋ%YPTS4\\4|6郮ZY(f},#ǀ<Z?/7lHjB_p`;ei\nu1/!BA1VV0Q2hx\$47!=)EV669m8Z\r6aX\$Ra7zP@02?\0N97<)hvG6di?4\\NI}@W*\03𕣱#wq_X1Z(O	)D՛1K,Z\\!vgxI{V*L\"\r/7뢹D\rgQW0*\n\0\$_z5\"&B'з1޺HPΐ:Z}\r~ꩅi_ PƃL27XjF^#l,֞8BÒ@PАSGhL>?}ܕ{U-HƕUC/7&(/\0۴Ț~-	+3\0le\nr*\0*;Cv:̰uPqnR@u[Pwa%.>Y2Tzh`%-d8yV^\05-pQ\"R\"	dZ=Cl<]2׷aAbK\rPdD3oU~`P,S\nyC(^QF`RB̖%2/(\n`q?d]FLrg\\'D҈rEeѫ[)YLA|@±7\$+ʂt;:1<yLOVnԤe{,	Ҥ^ WXr̒\"`a	S`~Z,)+L̀\$'lK\"?ua!@&xACNo!˲VSoM>8:C{~C/@!(Ex\"b]y~H3f/)47Β 9pP; yOrEmWnkdFقQ`V!9l0b.Q'n|i'HK2#NuQ֯S?!73회#@]x}YYqS b{e@ϩ4J%Kz7hRjD(	Wbm car'AHtS|nFd/Vcq0\\	Lo#/##є֬e\nE	/f(Du֪YD8!\\)ӠY5֒f3Heĵg%cG:PiXZY\08D_UX6Tg6!E\\k&\0R9[ػt57ŘAV(iS|r1_	=뤹CC}tD'KWk6b6 Th5f?Bq{0<5j(5s&<699s\r_Fc\0	FM5pިmB^ #RB\rJB0cKC_]Λƻw\n?ՄeJަmD+|fg3\$D~%#:6ojhoڞm}D0;ٵo}l(߲V`0fXӡ	#?( 3<İtN66ȵo\";Kqk8CṆHlZtSO&u7\r\rz[\rCuJu18-\n78f2#+5,zD:c\$m,zRjQ6w\r1hPݖdU	G?wA~;tMCe\rg4rn`t`4|Sŵk}+*Wp=ؠl`ɼ?+uJ{2Z@{x>7~zǀ'Ե%L[ůҥ aįdn\\89v2[@LOg_;q8]Nuba(Z=54ݣ0Pn,[qA>I]WºЁ'ݯ@Vu(uחQM۾kQ(p#TkhhC;N:nW\rMN3#|bic*&YJ_R\"*\08>Q@iN׌47ED38.4㍯7\n(&߅zvh#1r\$)x&]>ʕ");}elseif($_GET["file"]=="jush.js"){header("Content-Type: text/javascript; charset=utf-8");echo
lzw_decompress('');}else{header("Content-Type: image/gif");switch($_GET["file"]){case"plus.gif":echo'';break;case"cross.gif":echo'';break;case"up.gif":echo'';break;case"down.gif":echo'';break;case"arrow.gif":echo'';break;}}exit;}if($_GET["script"]=="version"){$n=file_open_lock(get_temp_dir()."/adminer.version");if($n)file_write_unlock($n,serialize(array("signature"=>$_POST["signature"],"version"=>$_POST["version"])));exit;}global$b,$f,$i,$sb,$wb,$Db,$j,$ic,$lc,$aa,$Dc,$v,$ba,$Pc,$td,$Ld,$Fe,$pc,$bf,$ff,$kf,$rf,$ca;if(!$_SERVER["REQUEST_URI"])$_SERVER["REQUEST_URI"]=$_SERVER["ORIG_PATH_INFO"];if(!strpos($_SERVER["REQUEST_URI"],'?')&&$_SERVER["QUERY_STRING"]!="")$_SERVER["REQUEST_URI"].="?$_SERVER[QUERY_STRING]";if($_SERVER["HTTP_X_FORWARDED_PREFIX"])$_SERVER["REQUEST_URI"]=$_SERVER["HTTP_X_FORWARDED_PREFIX"].$_SERVER["REQUEST_URI"];$aa=($_SERVER["HTTPS"]&&strcasecmp($_SERVER["HTTPS"],"off"))||ini_bool("session.cookie_secure");@ini_set("session.use_trans_sid",false);if(!defined("SID")){session_cache_limiter("");session_name("adminer_sid");$Gd=array(0,preg_replace('~\?.*~','',$_SERVER["REQUEST_URI"]),"",$aa);if(version_compare(PHP_VERSION,'5.2.0')>=0)$Gd[]=true;call_user_func_array('session_set_cookie_params',$Gd);session_start();}remove_slashes(array(&$_GET,&$_POST,&$_COOKIE),$Tb);if(function_exists("get_magic_quotes_runtime")&&get_magic_quotes_runtime())set_magic_quotes_runtime(false);@set_time_limit(0);@ini_set("zend.ze1_compatibility_mode",false);@ini_set("precision",15);function
get_lang(){return'he';}function
lang($ef,$qd=null){if(is_array($ef)){$Od=($qd==1?0:1);$ef=$ef[$Od];}$ef=str_replace("%d","%s",$ef);$qd=format_number($qd);return
sprintf($ef,$qd);}if(extension_loaded('pdo')){class
Min_PDO{var$_result,$server_info,$affected_rows,$errno,$error,$pdo;function
__construct(){global$b;$Od=array_search("SQL",$b->operators);if($Od!==false)unset($b->operators[$Od]);}function
dsn($ub,$U,$G,$D=array()){$D[PDO::ATTR_ERRMODE]=PDO::ERRMODE_SILENT;$D[PDO::ATTR_STATEMENT_CLASS]=array('Min_PDOStatement');try{$this->pdo=new
PDO($ub,$U,$G,$D);}catch(Exception$Ib){auth_error(h($Ib->getMessage()));}$this->server_info=@$this->pdo->getAttribute(PDO::ATTR_SERVER_VERSION);}function
quote($R){return$this->pdo->quote($R);}function
query($I,$lf=false){$J=$this->pdo->query($I);$this->error="";if(!$J){list(,$this->errno,$this->error)=$this->pdo->errorInfo();if(!$this->error)$this->error='Unknown error.';return
false;}$this->store_result($J);return$J;}function
multi_query($I){return$this->_result=$this->query($I);}function
store_result($J=null){if(!$J){$J=$this->_result;if(!$J)return
false;}if($J->columnCount()){$J->num_rows=$J->rowCount();return$J;}$this->affected_rows=$J->rowCount();return
true;}function
next_result(){if(!$this->_result)return
false;$this->_result->_offset=0;return@$this->_result->nextRowset();}function
result($I,$k=0){$J=$this->query($I);if(!$J)return
false;$L=$J->fetch();return$L[$k];}}class
Min_PDOStatement
extends
PDOStatement{var$_offset=0,$num_rows;function
fetch_assoc(){return$this->fetch(PDO::FETCH_ASSOC);}function
fetch_row(){return$this->fetch(PDO::FETCH_NUM);}function
fetch_field(){$L=(object)$this->getColumnMeta($this->_offset++);$L->orgtable=$L->table;$L->orgname=$L->name;$L->charsetnr=(in_array("blob",(array)$L->flags)?63:0);return$L;}}}$sb=array();function
add_driver($r,$C){global$sb;$sb[$r]=$C;}function
get_driver($r){global$sb;return$sb[$r];}class
Min_SQL{var$_conn;function
__construct($f){$this->_conn=$f;}function
select($S,$N,$Z,$p,$E=array(),$x=1,$F=0,$Sd=false){global$b,$v;$Ic=(count($p)<count($N));$I=$b->selectQueryBuild($N,$Z,$p,$E,$x,$F);if(!$I)$I="SELECT".limit(($_GET["page"]!="last"&&$x!=""&&$p&&$Ic&&$v=="sql"?"SQL_CALC_FOUND_ROWS ":"").implode(", ",$N)."\nFROM ".table($S),($Z?"\nWHERE ".implode(" AND ",$Z):"").($p&&$Ic?"\nGROUP BY ".implode(", ",$p):"").($E?"\nORDER BY ".implode(", ",$E):""),($x!=""?+$x:null),($F?$x*$F:0),"\n");$De=microtime(true);$K=$this->_conn->query($I);if($Sd)echo$b->selectQuery($I,$De,!$K);return$K;}function
delete($S,$Xd,$x=0){$I="FROM ".table($S);return
queries("DELETE".($x?limit1($S,$I,$Xd):" $I$Xd"));}function
update($S,$P,$Xd,$x=0,$se="\n"){$yf=array();foreach($P
as$w=>$W)$yf[]="$w = $W";$I=table($S)." SET$se".implode(",$se",$yf);return
queries("UPDATE".($x?limit1($S,$I,$Xd,$se):" $I$Xd"));}function
insert($S,$P){return
queries("INSERT INTO ".table($S).($P?" (".implode(", ",array_keys($P)).")\nVALUES (".implode(", ",$P).")":" DEFAULT VALUES"));}function
insertUpdate($S,$M,$Rd){return
false;}function
begin(){return
queries("BEGIN");}function
commit(){return
queries("COMMIT");}function
rollback(){return
queries("ROLLBACK");}function
slowQuery($I,$Ve){}function
convertSearch($s,$W,$k){return$s;}function
value($W,$k){return(method_exists($this->_conn,'value')?$this->_conn->value($W,$k):(is_resource($W)?stream_get_contents($W):$W));}function
quoteBinary($ke){return
q($ke);}function
warnings(){return'';}function
tableHelp($C){}}$sb["pgsql"]="PostgreSQL";define("DRIVER","pgsql");if(extension_loaded("pgsql")){class
Min_DB{var$extension="PgSQL",$_link,$_result,$_string,$_database=true,$server_info,$affected_rows,$error,$timeout;function
_error($Fb,$j){if(ini_bool("html_errors"))$j=html_entity_decode(strip_tags($j));$j=preg_replace('~^[^:]*: ~','',$j);$this->error=$j;}function
connect($O,$U,$G){global$b;$h=$b->database();set_error_handler(array($this,'_error'));$this->_string="host='".str_replace(":","' port='",addcslashes($O,"'\\"))."' user='".addcslashes($U,"'\\")."' password='".addcslashes($G,"'\\")."'";$this->_link=@pg_connect("$this->_string dbname='".($h!=""?addcslashes($h,"'\\"):"postgres")."'",PGSQL_CONNECT_FORCE_NEW);if(!$this->_link&&$h!=""){$this->_database=false;$this->_link=@pg_connect("$this->_string dbname='postgres'",PGSQL_CONNECT_FORCE_NEW);}restore_error_handler();if($this->_link){$zf=pg_version($this->_link);$this->server_info=$zf["server"];pg_set_client_encoding($this->_link,"UTF8");}return(bool)$this->_link;}function
quote($R){return"'".pg_escape_string($this->_link,$R)."'";}function
value($W,$k){return($k["type"]=="bytea"&&$W!==null?pg_unescape_bytea($W):$W);}function
quoteBinary($R){return"'".pg_escape_bytea($this->_link,$R)."'";}function
select_db($ib){global$b;if($ib==$b->database())return$this->_database;$K=@pg_connect("$this->_string dbname='".addcslashes($ib,"'\\")."'",PGSQL_CONNECT_FORCE_NEW);if($K)$this->_link=$K;return$K;}function
close(){$this->_link=@pg_connect("$this->_string dbname='postgres'");}function
query($I,$lf=false){$J=@pg_query($this->_link,$I);$this->error="";if(!$J){$this->error=pg_last_error($this->_link);$K=false;}elseif(!pg_num_fields($J)){$this->affected_rows=pg_affected_rows($J);$K=true;}else$K=new
Min_Result($J);if($this->timeout){$this->timeout=0;$this->query("RESET statement_timeout");}return$K;}function
multi_query($I){return$this->_result=$this->query($I);}function
store_result(){return$this->_result;}function
next_result(){return
false;}function
result($I,$k=0){$J=$this->query($I);if(!$J||!$J->num_rows)return
false;return
pg_fetch_result($J->_result,0,$k);}function
warnings(){return
h(pg_last_notice($this->_link));}}class
Min_Result{var$_result,$_offset=0,$num_rows;function
__construct($J){$this->_result=$J;$this->num_rows=pg_num_rows($J);}function
fetch_assoc(){return
pg_fetch_assoc($this->_result);}function
fetch_row(){return
pg_fetch_row($this->_result);}function
fetch_field(){$d=$this->_offset++;$K=new
stdClass;if(function_exists('pg_field_table'))$K->orgtable=pg_field_table($this->_result,$d);$K->name=pg_field_name($this->_result,$d);$K->orgname=$K->name;$K->type=pg_field_type($this->_result,$d);$K->charsetnr=($K->type=="bytea"?63:0);return$K;}function
__destruct(){pg_free_result($this->_result);}}}elseif(extension_loaded("pdo_pgsql")){class
Min_DB
extends
Min_PDO{var$extension="PDO_PgSQL",$timeout;function
connect($O,$U,$G){global$b;$h=$b->database();$this->dsn("pgsql:host='".str_replace(":","' port='",addcslashes($O,"'\\"))."' client_encoding=utf8 dbname='".($h!=""?addcslashes($h,"'\\"):"postgres")."'",$U,$G);return
true;}function
select_db($ib){global$b;return($b->database()==$ib);}function
quoteBinary($ke){return
q($ke);}function
query($I,$lf=false){$K=parent::query($I,$lf);if($this->timeout){$this->timeout=0;parent::query("RESET statement_timeout");}return$K;}function
warnings(){return'';}function
close(){}}}class
Min_Driver
extends
Min_SQL{function
insertUpdate($S,$M,$Rd){global$f;foreach($M
as$P){$sf=array();$Z=array();foreach($P
as$w=>$W){$sf[]="$w = $W";if(isset($Rd[idf_unescape($w)]))$Z[]="$w = $W";}if(!(($Z&&queries("UPDATE ".table($S)." SET ".implode(", ",$sf)." WHERE ".implode(" AND ",$Z))&&$f->affected_rows)||queries("INSERT INTO ".table($S)." (".implode(", ",array_keys($P)).") VALUES (".implode(", ",$P).")")))return
false;}return
true;}function
slowQuery($I,$Ve){$this->_conn->query("SET statement_timeout = ".(1000*$Ve));$this->_conn->timeout=1000*$Ve;return$I;}function
convertSearch($s,$W,$k){return(preg_match('~char|text'.(!preg_match('~LIKE~',$W["op"])?'|date|time(stamp)?|boolean|uuid|'.number_type():'').'~',$k["type"])?$s:"CAST($s AS text)");}function
quoteBinary($ke){return$this->_conn->quoteBinary($ke);}function
warnings(){return$this->_conn->warnings();}function
tableHelp($C){$Wc=array("information_schema"=>"infoschema","pg_catalog"=>"catalog",);$y=$Wc[$_GET["ns"]];if($y)return"$y-".str_replace("_","-",$C).".html";}}function
idf_escape($s){return'"'.str_replace('"','""',$s).'"';}function
table($s){return
idf_escape($s);}function
connect(){global$b,$kf,$Fe;$f=new
Min_DB;$db=$b->credentials();if($f->connect($db[0],$db[1],$db[2])){if(min_version(9,0,$f)){$f->query("SET application_name = 'Adminer'");if(min_version(9.2,0,$f)){$Fe['מחרוזות'][]="json";$kf["json"]=4294967295;if(min_version(9.4,0,$f)){$Fe['מחרוזות'][]="jsonb";$kf["jsonb"]=4294967295;}}}return$f;}return$f->error;}function
get_databases(){return
get_vals("SELECT datname FROM pg_database WHERE has_database_privilege(datname, 'CONNECT') ORDER BY datname");}function
limit($I,$Z,$x,$rd=0,$se=" "){return" $I$Z".($x!==null?$se."LIMIT $x".($rd?" OFFSET $rd":""):"");}function
limit1($S,$I,$Z,$se="\n"){return(preg_match('~^INTO~',$I)?limit($I,$Z,1,0,$se):" $I".(is_view(table_status1($S))?$Z:$se."WHERE ctid = (SELECT ctid FROM ".table($S).$Z.$se."LIMIT 1)"));}function
db_collation($h,$Qa){global$f;return$f->result("SELECT datcollate FROM pg_database WHERE datname = ".q($h));}function
engines(){return
array();}function
logged_user(){global$f;return$f->result("SELECT user");}function
tables_list(){$I="SELECT table_name, table_type FROM information_schema.tables WHERE table_schema = current_schema()";if(support('materializedview'))$I.="
UNION ALL
SELECT matviewname, 'MATERIALIZED VIEW'
FROM pg_matviews
WHERE schemaname = current_schema()";$I.="
ORDER BY 1";return
get_key_vals($I);}function
count_tables($jb){return
array();}function
table_status($C=""){$K=array();foreach(get_rows("SELECT c.relname AS \"Name\", CASE c.relkind WHEN 'r' THEN 'table' WHEN 'm' THEN 'materialized view' ELSE 'view' END AS \"Engine\", pg_relation_size(c.oid) AS \"Data_length\", pg_total_relation_size(c.oid) - pg_relation_size(c.oid) AS \"Index_length\", obj_description(c.oid, 'pg_class') AS \"Comment\", ".(min_version(12)?"''":"CASE WHEN c.relhasoids THEN 'oid' ELSE '' END")." AS \"Oid\", c.reltuples as \"Rows\", n.nspname
FROM pg_class c
JOIN pg_namespace n ON(n.nspname = current_schema() AND n.oid = c.relnamespace)
WHERE relkind IN ('r', 'm', 'v', 'f', 'p')
".($C!=""?"AND relname = ".q($C):"ORDER BY relname"))as$L)$K[$L["Name"]]=$L;return($C!=""?$K[$C]:$K);}function
is_view($T){return
in_array($T["Engine"],array("view","materialized view"));}function
fk_support($T){return
true;}function
fields($S){$K=array();$oa=array('timestamp without time zone'=>'timestamp','timestamp with time zone'=>'timestamptz',);foreach(get_rows("SELECT a.attname AS field, format_type(a.atttypid, a.atttypmod) AS full_type, pg_get_expr(d.adbin, d.adrelid) AS default, a.attnotnull::int, col_description(c.oid, a.attnum) AS comment".(min_version(10)?", a.attidentity":"")."
FROM pg_class c
JOIN pg_namespace n ON c.relnamespace = n.oid
JOIN pg_attribute a ON c.oid = a.attrelid
LEFT JOIN pg_attrdef d ON c.oid = d.adrelid AND a.attnum = d.adnum
WHERE c.relname = ".q($S)."
AND n.nspname = current_schema()
AND NOT a.attisdropped
AND a.attnum > 0
ORDER BY a.attnum")as$L){preg_match('~([^([]+)(\((.*)\))?([a-z ]+)?((\[[0-9]*])*)$~',$L["full_type"],$_);list(,$jf,$Tc,$L["length"],$ka,$ra)=$_;$L["length"].=$ra;$Ha=$jf.$ka;if(isset($oa[$Ha])){$L["type"]=$oa[$Ha];$L["full_type"]=$L["type"].$Tc.$ra;}else{$L["type"]=$jf;$L["full_type"]=$L["type"].$Tc.$ka.$ra;}if(in_array($L['attidentity'],array('a','d')))$L['default']='GENERATED '.($L['attidentity']=='d'?'BY DEFAULT':'ALWAYS').' AS IDENTITY';$L["null"]=!$L["attnotnull"];$L["auto_increment"]=$L['attidentity']||preg_match('~^nextval\(~i',$L["default"]);$L["privileges"]=array("insert"=>1,"select"=>1,"update"=>1);if(preg_match('~(.+)::[^,)]+(.*)~',$L["default"],$_))$L["default"]=($_[1]=="NULL"?null:idf_unescape($_[1]).$_[2]);$K[$L["field"]]=$L;}return$K;}function
indexes($S,$g=null){global$f;if(!is_object($g))$g=$f;$K=array();$Ne=$g->result("SELECT oid FROM pg_class WHERE relnamespace = (SELECT oid FROM pg_namespace WHERE nspname = current_schema()) AND relname = ".q($S));$e=get_key_vals("SELECT attnum, attname FROM pg_attribute WHERE attrelid = $Ne AND attnum > 0",$g);foreach(get_rows("SELECT relname, indisunique::int, indisprimary::int, indkey, indoption, (indpred IS NOT NULL)::int as indispartial FROM pg_index i, pg_class ci WHERE i.indrelid = $Ne AND ci.oid = i.indexrelid",$g)as$L){$de=$L["relname"];$K[$de]["type"]=($L["indispartial"]?"INDEX":($L["indisprimary"]?"PRIMARY":($L["indisunique"]?"UNIQUE":"INDEX")));$K[$de]["columns"]=array();foreach(explode(" ",$L["indkey"])as$Ac)$K[$de]["columns"][]=$e[$Ac];$K[$de]["descs"]=array();foreach(explode(" ",$L["indoption"])as$Bc)$K[$de]["descs"][]=($Bc&1?'1':null);$K[$de]["lengths"]=array();}return$K;}function
foreign_keys($S){global$td;$K=array();foreach(get_rows("SELECT conname, condeferrable::int AS deferrable, pg_get_constraintdef(oid) AS definition
FROM pg_constraint
WHERE conrelid = (SELECT pc.oid FROM pg_class AS pc INNER JOIN pg_namespace AS pn ON (pn.oid = pc.relnamespace) WHERE pc.relname = ".q($S)." AND pn.nspname = current_schema())
AND contype = 'f'::char
ORDER BY conkey, conname")as$L){if(preg_match('~FOREIGN KEY\s*\((.+)\)\s*REFERENCES (.+)\((.+)\)(.*)$~iA',$L['definition'],$_)){$L['source']=array_map('idf_unescape',array_map('trim',explode(',',$_[1])));if(preg_match('~^(("([^"]|"")+"|[^"]+)\.)?"?("([^"]|"")+"|[^"]+)$~',$_[2],$bd)){$L['ns']=idf_unescape($bd[2]);$L['table']=idf_unescape($bd[4]);}$L['target']=array_map('idf_unescape',array_map('trim',explode(',',$_[3])));$L['on_delete']=(preg_match("~ON DELETE ($td)~",$_[4],$bd)?$bd[1]:'NO ACTION');$L['on_update']=(preg_match("~ON UPDATE ($td)~",$_[4],$bd)?$bd[1]:'NO ACTION');$K[$L['conname']]=$L;}}return$K;}function
constraints($S){global$td;$K=array();foreach(get_rows("SELECT conname, consrc
FROM pg_catalog.pg_constraint
INNER JOIN pg_catalog.pg_namespace ON pg_constraint.connamespace = pg_namespace.oid
INNER JOIN pg_catalog.pg_class ON pg_constraint.conrelid = pg_class.oid AND pg_constraint.connamespace = pg_class.relnamespace
WHERE pg_constraint.contype = 'c'
AND conrelid != 0 -- handle only CONSTRAINTs here, not TYPES
AND nspname = current_schema()
AND relname = ".q($S)."
ORDER BY connamespace, conname")as$L)$K[$L['conname']]=$L['consrc'];return$K;}function
view($C){global$f;return
array("select"=>trim($f->result("SELECT pg_get_viewdef(".$f->result("SELECT oid FROM pg_class WHERE relnamespace = (SELECT oid FROM pg_namespace WHERE nspname = current_schema()) AND relname = ".q($C)).")")));}function
collations(){return
array();}function
information_schema($h){return($h=="information_schema");}function
error(){global$f;$K=h($f->error);if(preg_match('~^(.*\n)?([^\n]*)\n( *)\^(\n.*)?$~s',$K,$_))$K=$_[1].preg_replace('~((?:[^&]|&[^;]*;){'.strlen($_[3]).'})(.*)~','\1<b>\2</b>',$_[2]).$_[4];return
nl_br($K);}function
create_database($h,$Pa){return
queries("CREATE DATABASE ".idf_escape($h).($Pa?" ENCODING ".idf_escape($Pa):""));}function
drop_databases($jb){global$f;$f->close();return
apply_queries("DROP DATABASE",$jb,'idf_escape');}function
rename_database($C,$Pa){return
queries("ALTER DATABASE ".idf_escape(DB)." RENAME TO ".idf_escape($C));}function
auto_increment(){return"";}function
alter_table($S,$C,$l,$ac,$Ta,$Cb,$Pa,$wa,$Id){$pa=array();$H=array();if($S!=""&&$S!=$C)$H[]="ALTER TABLE ".table($S)." RENAME TO ".table($C);foreach($l
as$k){$d=idf_escape($k[0]);$W=$k[1];if(!$W)$pa[]="DROP $d";else{$xf=$W[5];unset($W[5]);if($k[0]==""){if(isset($W[6]))$W[1]=($W[1]==" bigint"?" big":($W[1]==" smallint"?" small":" "))."serial";$pa[]=($S!=""?"ADD ":"  ").implode($W);if(isset($W[6]))$pa[]=($S!=""?"ADD":" ")." PRIMARY KEY ($W[0])";}else{if($d!=$W[0])$H[]="ALTER TABLE ".table($C)." RENAME $d TO $W[0]";$pa[]="ALTER $d TYPE$W[1]";if(!$W[6]){$pa[]="ALTER $d ".($W[3]?"SET$W[3]":"DROP DEFAULT");$pa[]="ALTER $d ".($W[2]==" NULL"?"DROP NOT":"SET").$W[2];}}if($k[0]!=""||$xf!="")$H[]="COMMENT ON COLUMN ".table($C).".$W[0] IS ".($xf!=""?substr($xf,9):"''");}}$pa=array_merge($pa,$ac);if($S=="")array_unshift($H,"CREATE TABLE ".table($C)." (\n".implode(",\n",$pa)."\n)");elseif($pa)array_unshift($H,"ALTER TABLE ".table($S)."\n".implode(",\n",$pa));if($Ta!==null)$H[]="COMMENT ON TABLE ".table($C)." IS ".q($Ta);if($wa!=""){}foreach($H
as$I){if(!queries($I))return
false;}return
true;}function
alter_indexes($S,$pa){$cb=array();$tb=array();$H=array();foreach($pa
as$W){if($W[0]!="INDEX")$cb[]=($W[2]=="DROP"?"\nDROP CONSTRAINT ".idf_escape($W[1]):"\nADD".($W[1]!=""?" CONSTRAINT ".idf_escape($W[1]):"")." $W[0] ".($W[0]=="PRIMARY"?"KEY ":"")."(".implode(", ",$W[2]).")");elseif($W[2]=="DROP")$tb[]=idf_escape($W[1]);else$H[]="CREATE INDEX ".idf_escape($W[1]!=""?$W[1]:uniqid($S."_"))." ON ".table($S)." (".implode(", ",$W[2]).")";}if($cb)array_unshift($H,"ALTER TABLE ".table($S).implode(",",$cb));if($tb)array_unshift($H,"DROP INDEX ".implode(", ",$tb));foreach($H
as$I){if(!queries($I))return
false;}return
true;}function
truncate_tables($Oe){return
queries("TRUNCATE ".implode(", ",array_map('table',$Oe)));return
true;}function
drop_views($Af){return
drop_tables($Af);}function
drop_tables($Oe){foreach($Oe
as$S){$Q=table_status($S);if(!queries("DROP ".strtoupper($Q["Engine"])." ".table($S)))return
false;}return
true;}function
move_tables($Oe,$Af,$Qe){foreach(array_merge($Oe,$Af)as$S){$Q=table_status($S);if(!queries("ALTER ".strtoupper($Q["Engine"])." ".table($S)." SET SCHEMA ".idf_escape($Qe)))return
false;}return
true;}function
trigger($C,$S){if($C=="")return
array("Statement"=>"EXECUTE PROCEDURE ()");$e=array();$Z="WHERE trigger_schema = current_schema() AND event_object_table = ".q($S)." AND trigger_name = ".q($C);foreach(get_rows("SELECT * FROM information_schema.triggered_update_columns $Z")as$L)$e[]=$L["event_object_column"];$K=array();foreach(get_rows('SELECT trigger_name AS "Trigger", action_timing AS "Timing", event_manipulation AS "Event", \'FOR EACH \' || action_orientation AS "Type", action_statement AS "Statement" FROM information_schema.triggers '."$Z ORDER BY event_manipulation DESC")as$L){if($e&&$L["Event"]=="UPDATE")$L["Event"].=" OF";$L["Of"]=implode(", ",$e);if($K)$L["Event"].=" OR $K[Event]";$K=$L;}return$K;}function
triggers($S){$K=array();foreach(get_rows("SELECT * FROM information_schema.triggers WHERE trigger_schema = current_schema() AND event_object_table = ".q($S))as$L){$if=trigger($L["trigger_name"],$S);$K[$if["Trigger"]]=array($if["Timing"],$if["Event"]);}return$K;}function
trigger_options(){return
array("Timing"=>array("BEFORE","AFTER"),"Event"=>array("INSERT","UPDATE","UPDATE OF","DELETE","INSERT OR UPDATE","INSERT OR UPDATE OF","DELETE OR INSERT","DELETE OR UPDATE","DELETE OR UPDATE OF","DELETE OR INSERT OR UPDATE","DELETE OR INSERT OR UPDATE OF"),"Type"=>array("FOR EACH ROW","FOR EACH STATEMENT"),);}function
routine($C,$jf){$M=get_rows('SELECT routine_definition AS definition, LOWER(external_language) AS language, *
FROM information_schema.routines
WHERE routine_schema = current_schema() AND specific_name = '.q($C));$K=$M[0];$K["returns"]=array("type"=>$K["type_udt_name"]);$K["fields"]=get_rows('SELECT parameter_name AS field, data_type AS type, character_maximum_length AS length, parameter_mode AS inout
FROM information_schema.parameters
WHERE specific_schema = current_schema() AND specific_name = '.q($C).'
ORDER BY ordinal_position');return$K;}function
routines(){return
get_rows('SELECT specific_name AS "SPECIFIC_NAME", routine_type AS "ROUTINE_TYPE", routine_name AS "ROUTINE_NAME", type_udt_name AS "DTD_IDENTIFIER"
FROM information_schema.routines
WHERE routine_schema = current_schema()
ORDER BY SPECIFIC_NAME');}function
routine_languages(){return
get_vals("SELECT LOWER(lanname) FROM pg_catalog.pg_language");}function
routine_id($C,$L){$K=array();foreach($L["fields"]as$k)$K[]=$k["type"];return
idf_escape($C)."(".implode(", ",$K).")";}function
last_id(){return
0;}function
explain($f,$I){return$f->query("EXPLAIN $I");}function
found_rows($T,$Z){global$f;if(preg_match("~ rows=([0-9]+)~",$f->result("EXPLAIN SELECT * FROM ".idf_escape($T["Name"]).($Z?" WHERE ".implode(" AND ",$Z):"")),$ce))return$ce[1];return
false;}function
types(){return
get_vals("SELECT typname
FROM pg_type
WHERE typnamespace = (SELECT oid FROM pg_namespace WHERE nspname = current_schema())
AND typtype IN ('b','d','e')
AND typelem = 0");}function
schemas(){return
get_vals("SELECT nspname FROM pg_namespace ORDER BY nspname");}function
get_schema(){global$f;return$f->result("SELECT current_schema()");}function
set_schema($le,$g=null){global$f,$kf,$Fe;if(!$g)$g=$f;$K=$g->query("SET search_path TO ".idf_escape($le));foreach(types()as$jf){if(!isset($kf[$jf])){$kf[$jf]=0;$Fe['סוגי משתמשים'][]=$jf;}}return$K;}function
foreign_keys_sql($S){$K="";$Q=table_status($S);$Xb=foreign_keys($S);ksort($Xb);foreach($Xb
as$Wb=>$Vb)$K.="ALTER TABLE ONLY ".idf_escape($Q['nspname']).".".idf_escape($Q['Name'])." ADD CONSTRAINT ".idf_escape($Wb)." $Vb[definition] ".($Vb['deferrable']?'DEFERRABLE':'NOT DEFERRABLE').";\n";return($K?"$K\n":$K);}function
create_sql($S,$wa,$Ge){global$f;$K='';$ie=array();$ue=array();$Q=table_status($S);if(is_view($Q)){$_f=view($S);return
rtrim("CREATE VIEW ".idf_escape($S)." AS $_f[select]",";");}$l=fields($S);$u=indexes($S);ksort($u);$Za=constraints($S);if(!$Q||empty($l))return
false;$K="CREATE TABLE ".idf_escape($Q['nspname']).".".idf_escape($Q['Name'])." (\n    ";foreach($l
as$Qb=>$k){$Hd=idf_escape($k['field']).' '.$k['full_type'].default_value($k).($k['attnotnull']?" NOT NULL":"");$ie[]=$Hd;if(preg_match('~nextval\(\'([^\']+)\'\)~',$k['default'],$cd)){$te=$cd[1];$Be=reset(get_rows(min_version(10)?"SELECT *, cache_size AS cache_value FROM pg_sequences WHERE schemaname = current_schema() AND sequencename = ".q($te):"SELECT * FROM $te"));$ue[]=($Ge=="DROP+CREATE"?"DROP SEQUENCE IF EXISTS $te;\n":"")."CREATE SEQUENCE $te INCREMENT $Be[increment_by] MINVALUE $Be[min_value] MAXVALUE $Be[max_value]".($wa&&$Be['last_value']?" START $Be[last_value]":"")." CACHE $Be[cache_value];";}}if(!empty($ue))$K=implode("\n\n",$ue)."\n\n$K";foreach($u
as$zc=>$t){switch($t['type']){case'UNIQUE':$ie[]="CONSTRAINT ".idf_escape($zc)." UNIQUE (".implode(', ',array_map('idf_escape',$t['columns'])).")";break;case'PRIMARY':$ie[]="CONSTRAINT ".idf_escape($zc)." PRIMARY KEY (".implode(', ',array_map('idf_escape',$t['columns'])).")";break;}}foreach($Za
as$Xa=>$Ya)$ie[]="CONSTRAINT ".idf_escape($Xa)." CHECK $Ya";$K.=implode(",\n    ",$ie)."\n) WITH (oids = ".($Q['Oid']?'true':'false').");";foreach($u
as$zc=>$t){if($t['type']=='INDEX'){$e=array();foreach($t['columns']as$w=>$W)$e[]=idf_escape($W).($t['descs'][$w]?" DESC":"");$K.="\n\nCREATE INDEX ".idf_escape($zc)." ON ".idf_escape($Q['nspname']).".".idf_escape($Q['Name'])." USING btree (".implode(', ',$e).");";}}if($Q['Comment'])$K.="\n\nCOMMENT ON TABLE ".idf_escape($Q['nspname']).".".idf_escape($Q['Name'])." IS ".q($Q['Comment']).";";foreach($l
as$Qb=>$k){if($k['comment'])$K.="\n\nCOMMENT ON COLUMN ".idf_escape($Q['nspname']).".".idf_escape($Q['Name']).".".idf_escape($Qb)." IS ".q($k['comment']).";";}return
rtrim($K,';');}function
truncate_sql($S){return"TRUNCATE ".table($S);}function
trigger_sql($S){$Q=table_status($S);$K="";foreach(triggers($S)as$hf=>$gf){$if=trigger($hf,$Q['Name']);$K.="\nCREATE TRIGGER ".idf_escape($if['Trigger'])." $if[Timing] $if[Event] ON ".idf_escape($Q["nspname"]).".".idf_escape($Q['Name'])." $if[Type] $if[Statement];;\n";}return$K;}function
use_sql($ib){return"\connect ".idf_escape($ib);}function
show_variables(){return
get_key_vals("SHOW ALL");}function
process_list(){return
get_rows("SELECT * FROM pg_stat_activity ORDER BY ".(min_version(9.2)?"pid":"procpid"));}function
show_status(){}function
convert_field($k){}function
unconvert_field($k,$K){return$K;}function
support($Pb){return
preg_match('~^(database|table|columns|sql|indexes|descidx|comment|view|'.(min_version(9.3)?'materializedview|':'').'scheme|routine|processlist|sequence|trigger|type|variables|drop_col|kill|dump)$~',$Pb);}function
kill_process($W){return
queries("SELECT pg_terminate_backend(".number($W).")");}function
connection_id(){return"SELECT pg_backend_pid()";}function
max_connections(){global$f;return$f->result("SHOW max_connections");}function
driver_config(){$kf=array();$Fe=array();foreach(array('מספרים'=>array("smallint"=>5,"integer"=>10,"bigint"=>19,"boolean"=>1,"numeric"=>0,"real"=>7,"double precision"=>16,"money"=>20),'תאריך ושעה'=>array("date"=>13,"time"=>17,"timestamp"=>20,"timestamptz"=>21,"interval"=>0),'מחרוזות'=>array("character"=>0,"character varying"=>0,"text"=>0,"tsquery"=>0,"tsvector"=>0,"uuid"=>0,"xml"=>0),'בינארי'=>array("bit"=>0,"bit varying"=>0,"bytea"=>0),'רשת'=>array("cidr"=>43,"inet"=>43,"macaddr"=>17,"txid_snapshot"=>0),'גיאומטריה'=>array("box"=>0,"circle"=>0,"line"=>0,"lseg"=>0,"path"=>0,"point"=>0,"polygon"=>0),)as$w=>$W){$kf+=$W;$Fe[$w]=array_keys($W);}return
array('possible_drivers'=>array("PgSQL","PDO_PgSQL"),'jush'=>"pgsql",'types'=>$kf,'structured_types'=>$Fe,'unsigned'=>array(),'operators'=>array("=","<",">","<=",">=","!=","~","~*","!~","!~*","LIKE","LIKE %%","ILIKE","ILIKE %%","IN","IS NULL","NOT LIKE","NOT IN","IS NOT NULL"),'operator_regexp'=>'~*','functions'=>array("char_length","distinct","lower","round","to_hex","to_timestamp","upper"),'grouping'=>array("avg","count","count distinct","max","min","sum"),'edit_functions'=>array(array("char"=>"md5","date|time"=>"now",),array(number_type()=>"+/-","date|time"=>"+ interval/- interval","char|text"=>"||",)),);}class
Adminer{var$operators=array("<=",">=");var$_values=array();function
name(){return"<a href='https://www.adminer.org/editor/'".target_blank()." id='h1'>".'עורך'."</a>";}function
credentials(){return
array(SERVER,$_GET["username"],get_password());}function
connectSsl(){}function
permanentLogin($cb=false){return
password_file($cb);}function
bruteForceKey(){return$_SERVER["REMOTE_ADDR"];}function
serverName($O){}function
database(){global$f;if($f){$jb=$this->databases(false);return(!$jb?$f->result("SELECT SUBSTRING_INDEX(CURRENT_USER, '@', 1)"):$jb[(information_schema($jb[0])?1:0)]);}}function
schemas(){return
schemas();}function
databases($Yb=true){return
get_databases($Yb);}function
queryTimeout(){return
5;}function
headers(){}function
csp(){return
csp();}function
head(){return
true;}function
css(){$K=array();$m="adminer.css";if(file_exists($m))$K[]=$m;return$K;}function
loginForm(){echo"<table cellspacing='0' class='layout'>\n",$this->loginFormField('username','<tr><th>'.'שם משתמש'.'<td>','<input type="hidden" name="auth[driver]" value="server"><input name="auth[username]" id="username" value="'.h($_GET["username"]).'" autocomplete="username" autocapitalize="off">'.script("focus(qs('#username'));")),$this->loginFormField('password','<tr><th>'.'סיסמה'.'<td>','<input type="password" name="auth[password]" autocomplete="current-password">'."\n"),"</table>\n","<p><input type='submit' value='".'התחברות'."'>\n",checkbox("auth[permanent]",1,$_COOKIE["adminer_permanent"],'התחבר לצמיתות')."\n";}function
loginFormField($C,$sc,$X){return$sc.$X;}function
login($Yc,$G){return
true;}function
tableName($Le){return
h($Le["Comment"]!=""?$Le["Comment"]:$Le["Name"]);}function
fieldName($k,$E=0){return
h(preg_replace('~\s+\[.*\]$~','',($k["comment"]!=""?$k["comment"]:$k["field"])));}function
selectLinks($Le,$P=""){$a=$Le["Name"];if($P!==null)echo'<p class="tabs"><a href="'.h(ME.'edit='.urlencode($a).$P).'">'.'פריט חדש'."</a>\n";}function
foreignKeys($S){return
foreign_keys($S);}function
backwardKeys($S,$Ke){$K=array();foreach(get_rows("SELECT TABLE_NAME, CONSTRAINT_NAME, COLUMN_NAME, REFERENCED_COLUMN_NAME
FROM information_schema.KEY_COLUMN_USAGE
WHERE TABLE_SCHEMA = ".q($this->database())."
AND REFERENCED_TABLE_SCHEMA = ".q($this->database())."
AND REFERENCED_TABLE_NAME = ".q($S)."
ORDER BY ORDINAL_POSITION",null,"")as$L)$K[$L["TABLE_NAME"]]["keys"][$L["CONSTRAINT_NAME"]][$L["COLUMN_NAME"]]=$L["REFERENCED_COLUMN_NAME"];foreach($K
as$w=>$W){$C=$this->tableName(table_status($w,true));if($C!=""){$me=preg_quote($Ke);$se="(:|\\s*-)?\\s+";$K[$w]["name"]=(preg_match("(^$me$se(.+)|^(.+?)$se$me\$)iu",$C,$_)?$_[2].$_[3]:$C);}else
unset($K[$w]);}return$K;}function
backwardKeysPrint($za,$L){foreach($za
as$S=>$ya){foreach($ya["keys"]as$Ra){$y=ME.'select='.urlencode($S);$q=0;foreach($Ra
as$d=>$W)$y.=where_link($q++,$d,$L[$W]);echo"<a href='".h($y)."'>".h($ya["name"])."</a>";$y=ME.'edit='.urlencode($S);foreach($Ra
as$d=>$W)$y.="&set".urlencode("[".bracket_escape($d)."]")."=".urlencode($L[$W]);echo"<a href='".h($y)."' title='".'פריט חדש'."'>+</a> ";}}}function
selectQuery($I,$De,$Nb=false){return"<!--\n".str_replace("--","--><!-- ",$I)."\n(".format_time($De).")\n-->\n";}function
rowDescription($S){foreach(fields($S)as$k){if(preg_match("~varchar|character varying~",$k["type"]))return
idf_escape($k["field"]);}return"";}function
rowDescriptions($M,$cc){$K=$M;foreach($M[0]as$w=>$W){if(list($S,$r,$C)=$this->_foreignColumn($cc,$w)){$xc=array();foreach($M
as$L)$xc[$L[$w]]=q($L[$w]);$nb=$this->_values[$S];if(!$nb)$nb=get_key_vals("SELECT $r, $C FROM ".table($S)." WHERE $r IN (".implode(", ",$xc).")");foreach($M
as$B=>$L){if(isset($L[$w]))$K[$B][$w]=(string)$nb[$L[$w]];}}}return$K;}function
selectLink($W,$k){}function
selectVal($W,$y,$k,$Bd){$K=$W;$y=h($y);if(preg_match('~blob|bytea~',$k["type"])&&!is_utf8($W)){$K=sprintf('%d בתים',strlen($Bd));if(preg_match("~^(GIF|\xFF\xD8\xFF|\x89PNG\x0D\x0A\x1A\x0A)~",$Bd))$K="<img src='$y' alt='$K'>";}if(like_bool($k)&&$K!="")$K=(preg_match('~^(1|t|true|y|yes|on)$~i',$W)?'כן':'לא');if($y)$K="<a href='$y'".(is_url($y)?target_blank():"").">$K</a>";if(!$y&&!like_bool($k)&&preg_match(number_type(),$k["type"]))$K="<div class='number'>$K</div>";elseif(preg_match('~date~',$k["type"]))$K="<div class='datetime'>$K</div>";return$K;}function
editVal($W,$k){if(preg_match('~date|timestamp~',$k["type"])&&$W!==null)return
preg_replace('~^(\d{2}(\d+))-(0?(\d+))-(0?(\d+))~','$1-$3-$5',$W);return$W;}function
selectColumnsPrint($N,$e){}function
selectSearchPrint($Z,$e,$u){$Z=(array)$_GET["where"];echo'<fieldset id="fieldset-search"><legend>'.'חפש'."</legend><div>\n";$Lc=array();foreach($Z
as$w=>$W)$Lc[$W["col"]]=$w;$q=0;$l=fields($_GET["select"]);foreach($e
as$C=>$mb){$k=$l[$C];if(preg_match("~enum~",$k["type"])||like_bool($k)){$w=$Lc[$C];$q--;echo"<div>".h($mb)."<input type='hidden' name='where[$q][col]' value='".h($C)."'>:",(like_bool($k)?" <select name='where[$q][val]'>".optionlist(array(""=>"",'לא','כן'),$Z[$w]["val"],true)."</select>":enum_input("checkbox"," name='where[$q][val][]'",$k,(array)$Z[$w]["val"],($k["null"]?0:null))),"</div>\n";unset($e[$C]);}elseif(is_array($D=$this->_foreignKeyOptions($_GET["select"],$C))){if($l[$C]["null"])$D[0]='('.'ריק'.')';$w=$Lc[$C];$q--;echo"<div>".h($mb)."<input type='hidden' name='where[$q][col]' value='".h($C)."'><input type='hidden' name='where[$q][op]' value='='>: <select name='where[$q][val]'>".optionlist($D,$Z[$w]["val"],true)."</select></div>\n";unset($e[$C]);}}$q=0;foreach($Z
as$W){if(($W["col"]==""||$e[$W["col"]])&&"$W[col]$W[val]"!=""){echo"<div><select name='where[$q][col]'><option value=''>(".'בכל מקום'.")".optionlist($e,$W["col"],true)."</select>",html_select("where[$q][op]",array(-1=>"")+$this->operators,$W["op"]),"<input type='search' name='where[$q][val]' value='".h($W["val"])."'>".script("mixin(qsl('input'), {onkeydown: selectSearchKeydown, onsearch: selectSearchSearch});","")."</div>\n";$q++;}}echo"<div><select name='where[$q][col]'><option value=''>(".'בכל מקום'.")".optionlist($e,null,true)."</select>",script("qsl('select').onchange = selectAddRow;",""),html_select("where[$q][op]",array(-1=>"")+$this->operators),"<input type='search' name='where[$q][val]'></div>",script("mixin(qsl('input'), {onchange: function () { this.parentNode.firstChild.onchange(); }, onsearch: selectSearchSearch});"),"</div></fieldset>\n";}function
selectOrderPrint($E,$e,$u){$Ad=array();foreach($u
as$w=>$t){$E=array();foreach($t["columns"]as$W)$E[]=$e[$W];if(count(array_filter($E,'strlen'))>1&&$w!="PRIMARY")$Ad[$w]=implode(", ",$E);}if($Ad){echo'<fieldset><legend>'.'מיין'."</legend><div>","<select name='index_order'>".optionlist(array(""=>"")+$Ad,($_GET["order"][0]!=""?"":$_GET["index_order"]),true)."</select>","</div></fieldset>\n";}if($_GET["order"])echo"<div style='display: none;'>".hidden_fields(array("order"=>array(1=>reset($_GET["order"])),"desc"=>($_GET["desc"]?array(1=>1):array()),))."</div>\n";}function
selectLimitPrint($x){echo"<fieldset><legend>".'הגבל'."</legend><div>";echo
html_select("limit",array("","50","100"),$x),"</div></fieldset>\n";}function
selectLengthPrint($Se){}function
selectActionPrint($u){echo"<fieldset><legend>".'פעולות'."</legend><div>","<input type='submit' value='".'בחר'."'>","</div></fieldset>\n";}function
selectCommandPrint(){return
true;}function
selectImportPrint(){return
true;}function
selectEmailPrint($_b,$e){if($_b){print_fieldset("email",'דוא"ל',$_POST["email_append"]);echo"<div>",script("qsl('div').onkeydown = partialArg(bodyKeydown, 'email');"),"<p>".'מ:'.": <input name='email_from' value='".h($_POST?$_POST["email_from"]:$_COOKIE["adminer_email"])."'>\n",'נושא'.": <input name='email_subject' value='".h($_POST["email_subject"])."'>\n","<p><textarea name='email_message' rows='15' cols='75'>".h($_POST["email_message"].($_POST["email_append"]?'{$'."$_POST[email_addition]}":""))."</textarea>\n","<p>".script("qsl('p').onkeydown = partialArg(bodyKeydown, 'email_append');","").html_select("email_addition",$e,$_POST["email_addition"])."<input type='submit' name='email_append' value='".'הכנס'."'>\n";echo"<p>".'קבצים מצורפים'.": <input type='file' name='email_files[]'>".script("qsl('input').onchange = emailFileChange;"),"<p>".(count($_b)==1?'<input type="hidden" name="email_field" value="'.h(key($_b)).'">':html_select("email_field",$_b)),"<input type='submit' name='email' value='".'שלח'."'>".confirm(),"</div>\n","</div></fieldset>\n";}}function
selectColumnsProcess($e,$u){return
array(array(),array());}function
selectSearchProcess($l,$u){global$i;$K=array();foreach((array)$_GET["where"]as$w=>$Z){$Oa=$Z["col"];$wd=$Z["op"];$W=$Z["val"];if(($w<0?"":$Oa).$W!=""){$Ua=array();foreach(($Oa!=""?array($Oa=>$l[$Oa]):$l)as$C=>$k){if($Oa!=""||is_numeric($W)||!preg_match(number_type(),$k["type"])){$C=idf_escape($C);if($Oa!=""&&$k["type"]=="enum")$Ua[]=(in_array(0,$W)?"$C IS NULL OR ":"")."$C IN (".implode(", ",array_map('intval',$W)).")";else{$Te=preg_match('~char|text|enum|set~',$k["type"]);$X=$this->processInput($k,(!$wd&&$Te&&preg_match('~^[^%]+$~',$W)?"%$W%":$W));$Ua[]=$i->convertSearch($C,$W,$k).($X=="NULL"?" IS".($wd==">="?" NOT":"")." $X":(in_array($wd,$this->operators)||$wd=="="?" $wd $X":($Te?" LIKE $X":" IN (".str_replace(",","', '",$X).")")));if($w<0&&$W=="0")$Ua[]="$C IS NULL";}}}$K[]=($Ua?"(".implode(" OR ",$Ua).")":"1 = 0");}}return$K;}function
selectOrderProcess($l,$u){$_c=$_GET["index_order"];if($_c!="")unset($_GET["order"][1]);if($_GET["order"])return
array(idf_escape(reset($_GET["order"])).($_GET["desc"]?" DESC":""));foreach(($_c!=""?array($u[$_c]):$u)as$t){if($_c!=""||$t["type"]=="INDEX"){$nc=array_filter($t["descs"]);$mb=false;foreach($t["columns"]as$W){if(preg_match('~date|timestamp~',$l[$W]["type"])){$mb=true;break;}}$K=array();foreach($t["columns"]as$w=>$W)$K[]=idf_escape($W).(($nc?$t["descs"][$w]:$mb)?" DESC":"");return$K;}}return
array();}function
selectLimitProcess(){return(isset($_GET["limit"])?$_GET["limit"]:"50");}function
selectLengthProcess(){return"100";}function
selectEmailProcess($Z,$cc){if($_POST["email_append"])return
true;if($_POST["email"]){$qe=0;if($_POST["all"]||$_POST["check"]){$k=idf_escape($_POST["email_field"]);$He=$_POST["email_subject"];$A=$_POST["email_message"];preg_match_all('~\{\$([a-z0-9_]+)\}~i',"$He.$A",$cd);$M=get_rows("SELECT DISTINCT $k".($cd[1]?", ".implode(", ",array_map('idf_escape',array_unique($cd[1]))):"")." FROM ".table($_GET["select"])." WHERE $k IS NOT NULL AND $k != ''".($Z?" AND ".implode(" AND ",$Z):"").($_POST["all"]?"":" AND ((".implode(") OR (",array_map('where_check',(array)$_POST["check"]))."))"));$l=fields($_GET["select"]);foreach($this->rowDescriptions($M,$cc)as$L){$ee=array('{\\'=>'{');foreach($cd[1]as$W)$ee['{$'."$W}"]=$this->editVal($L[$W],$l[$W]);$zb=$L[$_POST["email_field"]];if(is_mail($zb)&&send_mail($zb,strtr($He,$ee),strtr($A,$ee),$_POST["email_from"],$_FILES["email_files"]))$qe++;}}cookie("adminer_email",$_POST["email_from"]);redirect(remove_from_uri(),sprintf('%d הודעות דוא"ל נשלחו',$qe));}return
false;}function
selectQueryBuild($N,$Z,$p,$E,$x,$F){return"";}function
messageQuery($I,$Ue,$Nb=false){return" <span class='time'>".@date("H:i:s")."</span><!--\n".str_replace("--","--><!-- ",$I)."\n".($Ue?"($Ue)\n":"")."-->";}function
editRowPrint($S,$l,$L,$sf){}function
editFunctions($k){$K=array();if($k["null"]&&preg_match('~blob~',$k["type"]))$K["NULL"]='ריק';$K[""]=($k["null"]||$k["auto_increment"]||like_bool($k)?"":"*");if(preg_match('~date|time~',$k["type"]))$K["now"]='כעת';if(preg_match('~_(md5|sha1)$~i',$k["field"],$_))$K[]=strtolower($_[1]);return$K;}function
editInput($S,$k,$c,$X){if($k["type"]=="enum")return(isset($_GET["select"])?"<label><input type='radio'$c value='-1' checked><i>".'מקורי'."</i></label> ":"").enum_input("radio",$c,$k,($X||isset($_GET["select"])?$X:0),($k["null"]?"":null));$D=$this->_foreignKeyOptions($S,$k["field"],$X);if($D!==null)return(is_array($D)?"<select$c>".optionlist($D,$X,true)."</select>":"<input value='".h($X)."'$c class='hidden'>"."<input value='".h($D)."' class='jsonly'>"."<div></div>".script("qsl('input').oninput = partial(whisper, '".ME."script=complete&source=".urlencode($S)."&field=".urlencode($k["field"])."&value=');
qsl('div').onclick = whisperClick;",""));if(like_bool($k))return'<input type="checkbox" value="1"'.(preg_match('~^(1|t|true|y|yes|on)$~i',$X)?' checked':'')."$c>";$tc="";if(preg_match('~time~',$k["type"]))$tc='HH:MM:SS';if(preg_match('~date|timestamp~',$k["type"]))$tc='[yyyy]-mm-dd'.($tc?" [$tc]":"");if($tc)return"<input value='".h($X)."'$c> ($tc)";if(preg_match('~_(md5|sha1)$~i',$k["field"]))return"<input type='password' value='".h($X)."'$c>";return'';}function
editHint($S,$k,$X){return(preg_match('~\s+(\[.*\])$~',($k["comment"]!=""?$k["comment"]:$k["field"]),$_)?h(" $_[1]"):'');}function
processInput($k,$X,$o=""){if($o=="now")return"$o()";$K=$X;if(preg_match('~date|timestamp~',$k["type"])&&preg_match('(^'.str_replace('\$1','(?P<p1>\d*)',preg_replace('~(\\\\\\$([2-6]))~','(?P<p\2>\d{1,2})',preg_quote('$1-$3-$5'))).'(.*))',$X,$_))$K=($_["p1"]!=""?$_["p1"]:($_["p2"]!=""?($_["p2"]<70?20:19).$_["p2"]:gmdate("Y")))."-$_[p3]$_[p4]-$_[p5]$_[p6]".end($_);$K=($k["type"]=="bit"&&preg_match('~^[0-9]+$~',$X)?$K:q($K));if($X==""&&like_bool($k))$K="'0'";elseif($X==""&&($k["null"]||!preg_match('~char|text~',$k["type"])))$K="NULL";elseif(preg_match('~^(md5|sha1)$~',$o))$K="$o($K)";return
unconvert_field($k,$K);}function
dumpOutput(){return
array();}function
dumpFormat(){return
array('csv'=>'CSV,','csv;'=>'CSV;','tsv'=>'TSV');}function
dumpDatabase($h){}function
dumpTable($S,$Ge,$Jc=0){echo"\xef\xbb\xbf";}function
dumpData($S,$Ge,$I){global$f;$J=$f->query($I,1);if($J){while($L=$J->fetch_assoc()){if($Ge=="table"){dump_csv(array_keys($L));$Ge="INSERT";}dump_csv($L);}}}function
dumpFilename($wc){return
friendly_url($wc);}function
dumpHeaders($wc,$kd=false){$Lb="csv";header("Content-Type: text/csv; charset=utf-8");return$Lb;}function
importServerPath(){}function
homepage(){return
true;}function
navigation($jd){global$ca;echo'<h1>
',$this->name(),' <span class="version">',$ca,'</span>
<a href="https://www.adminer.org/editor/#download"',target_blank(),' id="version">',(version_compare($ca,$_COOKIE["adminer_version"])<0?h($_COOKIE["adminer_version"]):""),'</a>
</h1>
';if($jd=="auth"){$Ub=true;foreach((array)$_SESSION["pwds"]as$Y=>$we){foreach($we[""]as$U=>$G){if($G!==null){if($Ub){echo"<ul id='logins'>",script("mixin(qs('#logins'), {onmouseover: menuOver, onmouseout: menuOut});");$Ub=false;}echo"<li><a href='".h(auth_url($Y,"",$U))."'>".($U!=""?h($U):"<i>".'ריק'."</i>")."</a>\n";}}}}else{$this->databasesPrint($jd);if($jd!="db"&&$jd!="ns"){$T=table_status('',true);if(!$T)echo"<p class='message'>".'אין טבלאות'."\n";else$this->tablesPrint($T);}}}function
databasesPrint($jd){}function
tablesPrint($Oe){echo"<ul id='tables'>",script("mixin(qs('#tables'), {onmouseover: menuOver, onmouseout: menuOut});");foreach($Oe
as$L){echo'<li>';$C=$this->tableName($L);if(isset($L["Engine"])&&$C!="")echo"<a href='".h(ME).'select='.urlencode($L["Name"])."'".bold($_GET["select"]==$L["Name"]||$_GET["edit"]==$L["Name"],"select")." title='".'בחר נתונים'."'>$C</a>\n";}echo"</ul>\n";}function
_foreignColumn($cc,$d){foreach((array)$cc[$d]as$bc){if(count($bc["source"])==1){$C=$this->rowDescription($bc["table"]);if($C!=""){$r=idf_escape($bc["target"][0]);return
array($bc["table"],$r,$C);}}}}function
_foreignKeyOptions($S,$d,$X=null){global$f;if(list($Qe,$r,$C)=$this->_foreignColumn(column_foreign_keys($S),$d)){$K=&$this->_values[$Qe];if($K===null){$T=table_status($Qe);$K=($T["Rows"]>1000?"":array(""=>"")+get_key_vals("SELECT $r, $C FROM ".table($Qe)." ORDER BY 2"));}if(!$K&&$X!==null)return$f->result("SELECT $C FROM ".table($Qe)." WHERE $r = ".q($X));return$K;}}}$b=(function_exists('adminer_object')?adminer_object():new
Adminer);$Va=driver_config();$Pd=$Va['possible_drivers'];$v=$Va['jush'];$kf=$Va['types'];$Fe=$Va['structured_types'];$rf=$Va['unsigned'];$zd=$Va['operators'];$yd=isset($Va['operator_regexp'])&&in_array($Va['operator_regexp'],$zd)?$Va['operator_regexp']:null;$ic=$Va['functions'];$lc=$Va['grouping'];$wb=$Va['edit_functions'];if($b->operators===null){$b->operators=$zd;$b->operator_regexp=$yd;}define("SERVER",$_GET[DRIVER]);define("DB",$_GET["db"]);define("ME",preg_replace('~\?.*~','',relative_uri()).'?'.(sid()?SID.'&':'').(SERVER!==null?DRIVER."=".urlencode(SERVER).'&':'').(isset($_GET["username"])?"username=".urlencode($_GET["username"]).'&':'').(DB!=""?'db='.urlencode(DB).'&'.(isset($_GET["ns"])?"ns=".urlencode($_GET["ns"])."&":""):''));$ca="4.8.3";function
page_header($We,$j="",$Fa=array(),$Xe=""){global$ba,$ca,$b,$sb,$v;page_headers();if(is_ajax()&&$j){page_messages($j);exit;}$Ye=$We.($Xe!=""?": $Xe":"");$Ze=strip_tags($Ye.(SERVER!=""&&SERVER!="localhost"?h(" - ".SERVER):"")." - ".$b->name());echo'<!DOCTYPE html>
<html lang="he" dir="rtl">
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="robots" content="noindex">
<title>',$Ze,'</title>
<link rel="stylesheet" type="text/css" href="',h(preg_replace("~\\?.*~","",ME)."?file=default.css&version=4.8.3"),'">
',script_src(preg_replace("~\\?.*~","",ME)."?file=functions.js&version=4.8.3");if($b->head()){echo'<link rel="shortcut icon" type="image/x-icon" href="',h(preg_replace("~\\?.*~","",ME)."?file=favicon.ico&version=4.8.3"),'">
<link rel="apple-touch-icon" href="',h(preg_replace("~\\?.*~","",ME)."?file=favicon.ico&version=4.8.3"),'">
';foreach($b->css()as$fb){echo'<link rel="stylesheet" type="text/css" href="',h($fb),'">
';}}echo'
<body class="rtl nojs">
';$m=get_temp_dir()."/adminer.version";if(!$_COOKIE["adminer_version"]&&function_exists('openssl_verify')&&file_exists($m)&&filemtime($m)+86400>time()){$zf=unserialize(file_get_contents($m));$Vd="-----BEGIN PUBLIC KEY-----
MIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEAwqWOVuF5uw7/+Z70djoK
RlHIZFZPO0uYRezq90+7Amk+FDNd7KkL5eDve+vHRJBLAszF/7XKXe11xwliIsFs
DFWQlsABVZB3oisKCBEuI71J4kPH8dKGEWR9jDHFw3cWmoH3PmqImX6FISWbG3B8
h7FIx3jEaw5ckVPVTeo5JRm/1DZzJxjyDenXvBQ/6o9DgZKeNDgxwKzH+sw9/YCO
jHnq1cFpOIISzARlrHMa/43YfeNRAm/tsBXjSxembBPo7aQZLAWHmaj5+K19H10B
nCpz9Y++cipkVEiKRGih4ZEvjoFysEOdRLj6WiD/uUNky4xGeA6LaJqh5XpkFkcQ
fQIDAQAB
-----END PUBLIC KEY-----
";if(openssl_verify($zf["version"],base64_decode($zf["signature"]),$Vd)==1)$_COOKIE["adminer_version"]=$zf["version"];}echo'<script',nonce(),'>
mixin(document.body, {onkeydown: bodyKeydown, onclick: bodyClick',(isset($_COOKIE["adminer_version"])?"":", onload: partial(verifyVersion, '$ca', '".js_escape(ME)."', '".get_token()."')");?>});
document.body.className = document.body.className.replace(/ nojs/, ' js');
var offlineMessage = '<?php echo
js_escape('הינך לא מקוון'),'\';
var thousandsSeparator = \'',js_escape(','),'\';
</script>

<div id="help" class="jush-',$v,' jsonly hidden"></div>
',script("mixin(qs('#help'), {onmouseover: function () { helpOpen = 1; }, onmouseout: helpMouseout});"),'
<div id="content">
';if($Fa!==null){$y=substr(preg_replace('~\b(username|db|ns)=[^&]*&~','',ME),0,-1);echo'<p id="breadcrumb"><a href="'.h($y?$y:".").'">'.$sb[DRIVER].'</a> &raquo; ';$y=substr(preg_replace('~\b(db|ns)=[^&]*&~','',ME),0,-1);$O=$b->serverName(SERVER);$O=($O!=""?$O:'שרת');if($Fa===false)echo"$O\n";else{echo"<a href='".h($y)."' accesskey='1' title='Alt+Shift+1'>$O</a> &raquo; ";if($_GET["ns"]!=""||(DB!=""&&is_array($Fa)))echo'<a href="'.h($y."&db=".urlencode(DB).(support("scheme")?"&ns=":"")).'">'.h(DB).'</a> &raquo; ';if(is_array($Fa)){if($_GET["ns"]!="")echo'<a href="'.h(substr(ME,0,-1)).'">'.h($_GET["ns"]).'</a> &raquo; ';foreach($Fa
as$w=>$W){$mb=(is_array($W)?$W[1]:h($W));if($mb!="")echo"<a href='".h(ME."$w=").urlencode(is_array($W)?$W[0]:$W)."'>$mb</a> &raquo; ";}}echo"$We\n";}}echo"<h2>$Ye</h2>\n","<div id='ajaxstatus' class='jsonly hidden'></div>\n";restart_session();page_messages($j);$jb=&get_session("dbs");if(DB!=""&&$jb&&!in_array(DB,$jb,true))$jb=null;stop_session();define("PAGE_HEADER",1);}function
page_headers(){global$b;header("Content-Type: text/html; charset=utf-8");header("Cache-Control: no-cache");header("X-Frame-Options: deny");header("X-XSS-Protection: 0");header("X-Content-Type-Options: nosniff");header("Referrer-Policy: origin-when-cross-origin");foreach($b->csp()as$eb){$qc=array();foreach($eb
as$w=>$W)$qc[]="$w $W";header("Content-Security-Policy: ".implode("; ",$qc));}$b->headers();}function
csp(){return
array(array("script-src"=>"'self' 'unsafe-inline' 'nonce-".get_nonce()."' 'strict-dynamic'","connect-src"=>"'self'","frame-src"=>"https://www.adminer.org","object-src"=>"'none'","base-uri"=>"'none'","form-action"=>"'self'",),);}function
get_nonce(){static$od;if(!$od)$od=base64_encode(rand_string());return$od;}function
page_messages($j){$tf=preg_replace('~^[^?]*~','',$_SERVER["REQUEST_URI"]);$id=$_SESSION["messages"][$tf];if($id){echo"<div class='message'>".implode("</div>\n<div class='message'>",$id)."</div>".script("messagesPrint();");unset($_SESSION["messages"][$tf]);}if($j)echo"<div class='error'>$j</div>\n";}function
page_footer($jd=""){global$b,$bf;echo'</div>

';if($jd!="auth"){echo'<form action="" method="post">
<p class="logout">
<input type="submit" name="logout" value="התנתק" id="logout">
<input type="hidden" name="token" value="',$bf,'">
</p>
</form>
';}echo'<div id="menu">
';$b->navigation($jd);echo'</div>
',script("setupSubmitHighlight(document);"),script("setupCopyToClipboard(document);"),"</body>\n</html>";}function
int32($B){while($B>=2147483648)$B-=4294967296;while($B<=-2147483649)$B+=4294967296;return(int)$B;}function
long2str($V,$Cf){$ke='';foreach($V
as$W)$ke.=pack('V',$W);if($Cf)return
substr($ke,0,end($V));return$ke;}function
str2long($ke,$Cf){$V=array_values(unpack('V*',str_pad($ke,4*ceil(strlen($ke)/4),"\0")));if($Cf)$V[]=strlen($ke);return$V;}function
xxtea_mx($Hf,$Gf,$Je,$Kc){return
int32((($Hf>>5&0x7FFFFFF)^$Gf<<2)+(($Gf>>3&0x1FFFFFFF)^$Hf<<4))^int32(($Je^$Gf)+($Kc^$Hf));}function
encrypt_string($Ee,$w){if($Ee=="")return"";$w=array_values(unpack("V*",pack("H*",md5($w))));$V=str2long($Ee,true);$B=count($V)-1;$Hf=$V[$B];$Gf=$V[0];$Wd=floor(6+52/($B+1));$Je=0;while($Wd-->0){$Je=int32($Je+0x9E3779B9);$vb=$Je>>2&3;for($Dd=0;$Dd<$B;$Dd++){$Gf=$V[$Dd+1];$ld=xxtea_mx($Hf,$Gf,$Je,$w[$Dd&3^$vb]);$Hf=int32($V[$Dd]+$ld);$V[$Dd]=$Hf;}$Gf=$V[0];$ld=xxtea_mx($Hf,$Gf,$Je,$w[$Dd&3^$vb]);$Hf=int32($V[$B]+$ld);$V[$B]=$Hf;}return
long2str($V,false);}function
decrypt_string($Ee,$w){if($Ee=="")return"";if(!$w)return
false;$w=array_values(unpack("V*",pack("H*",md5($w))));$V=str2long($Ee,false);$B=count($V)-1;$Hf=$V[$B];$Gf=$V[0];$Wd=floor(6+52/($B+1));$Je=int32($Wd*0x9E3779B9);while($Je){$vb=$Je>>2&3;for($Dd=$B;$Dd>0;$Dd--){$Hf=$V[$Dd-1];$ld=xxtea_mx($Hf,$Gf,$Je,$w[$Dd&3^$vb]);$Gf=int32($V[$Dd]-$ld);$V[$Dd]=$Gf;}$Hf=$V[$B];$ld=xxtea_mx($Hf,$Gf,$Je,$w[$Dd&3^$vb]);$Gf=int32($V[0]-$ld);$V[0]=$Gf;$Je=int32($Je-0x9E3779B9);}return
long2str($V,true);}$f='';$pc=$_SESSION["token"];if(!$pc)$_SESSION["token"]=rand(1,1e6);$bf=get_token();$Ld=array();if($_COOKIE["adminer_permanent"]){foreach(explode(" ",$_COOKIE["adminer_permanent"])as$W){list($w)=explode(":",$W);$Ld[$w]=$W;}}function
add_invalid_login(){global$b;$n=file_open_lock(get_temp_dir()."/adminer.invalid");if(!$n)return;$Gc=unserialize(stream_get_contents($n));$Ue=time();if($Gc){foreach($Gc
as$Hc=>$W){if($W[0]<$Ue)unset($Gc[$Hc]);}}$Fc=&$Gc[$b->bruteForceKey()];if(!$Fc)$Fc=array($Ue+30*60,0);$Fc[1]++;file_write_unlock($n,serialize($Gc));}function
check_invalid_login(){global$b;$Gc=unserialize(@file_get_contents(get_temp_dir()."/adminer.invalid"));$Fc=($Gc?$Gc[$b->bruteForceKey()]:array());$nd=($Fc[1]>29?$Fc[0]-time():0);if($nd>0)auth_error(sprintf('יותר מידי נסיונות כניסה נכשלו, אנא נסה עוד %d דקות',ceil($nd/60)));}$va=$_POST["auth"];if($va){session_regenerate_id();$Y=$va["driver"];$O=$va["server"];$U=$va["username"];$G=(string)$va["password"];$h=$va["db"];set_password($Y,$O,$U,$G);$_SESSION["db"][$Y][$O][$U][$h]=true;if($va["permanent"]){$w=base64_encode($Y)."-".base64_encode($O)."-".base64_encode($U)."-".base64_encode($h);$Td=$b->permanentLogin(true);$Ld[$w]="$w:".base64_encode($Td?encrypt_string($G,$Td):"");cookie("adminer_permanent",implode(" ",$Ld));}if(count($_POST)==1||DRIVER!=$Y||SERVER!=$O||$_GET["username"]!==$U||DB!=$h)redirect(auth_url($Y,$O,$U,$h));}elseif($_POST["logout"]&&(!$pc||verify_token())){foreach(array("pwds","db","dbs","queries")as$w)set_session($w,null);unset_permanent();redirect(substr(preg_replace('~\b(username|db|ns)=[^&]*&~','',ME),0,-1),'ההתחברות הצליחה'.'.');}elseif($Ld&&!$_SESSION["pwds"]){session_regenerate_id();$Td=$b->permanentLogin();foreach($Ld
as$w=>$W){list(,$Ka)=explode(":",$W);list($Y,$O,$U,$h)=array_map('base64_decode',explode("-",$w));set_password($Y,$O,$U,decrypt_string(base64_decode($Ka),$Td));$_SESSION["db"][$Y][$O][$U][$h]=true;}}function
unset_permanent(){global$Ld;foreach($Ld
as$w=>$W){list($Y,$O,$U,$h)=array_map('base64_decode',explode("-",$w));if($Y==DRIVER&&$O==SERVER&&$U==$_GET["username"]&&$h==DB)unset($Ld[$w]);}cookie("adminer_permanent",implode(" ",$Ld));}function
auth_error($j){global$b,$pc;$xe=session_name();if(isset($_GET["username"])){header("HTTP/1.1 403 Forbidden");if(($_COOKIE[$xe]||$_GET[$xe])&&!$pc)$j='תם זמן ההפעלה, אנא התחבר שוב';else{restart_session();add_invalid_login();$G=get_password();if($G!==null){if($G===false)$j.=($j?'<br>':'').sprintf('סיסמת המאסטר פגה <a href="https://www.adminer.org/en/extension/"%s>התקן תוסף</a> על מנת להפוך את זה לתמידי',target_blank(),'<code>permanentLogin()</code>');set_password(DRIVER,SERVER,$_GET["username"],null);}unset_permanent();}}if(!$_COOKIE[$xe]&&$_GET[$xe]&&ini_bool("session.use_only_cookies"))$j='חובה להפעיל תמיכה בסשן';$Gd=session_get_cookie_params();cookie("adminer_key",($_COOKIE["adminer_key"]?$_COOKIE["adminer_key"]:rand_string()),$Gd["lifetime"]);page_header('התחברות',$j,null);echo"<form action='' method='post'>\n","<div>";if(hidden_fields($_POST,array("auth")))echo"<p class='message'>".'The action will be performed after successful login with the same credentials.'."\n";echo"</div>\n";$b->loginForm();echo"</form>\n";page_footer("auth");exit;}if(isset($_GET["username"])&&!class_exists("Min_DB")){unset($_SESSION["pwds"][DRIVER]);unset_permanent();page_header('אין תוסף',sprintf('שום תוסף PHP (%s) זמין',implode(", ",$Pd)),false);page_footer("auth");exit;}stop_session(true);if(isset($_GET["username"])&&is_string(get_password())){list($uc,$Nd)=explode(":",SERVER,2);if(preg_match('~^\s*([-+]?\d+)~',$Nd,$_)&&($_[1]<1024||$_[1]>65535))auth_error('Connecting to privileged ports is not allowed.');check_invalid_login();$f=connect();$i=new
Min_Driver($f);}$Yc=null;if(!is_object($f)||($Yc=$b->login($_GET["username"],get_password()))!==true){$j=(is_string($f)?h($f):(is_string($Yc)?$Yc:'פרטי התחברות שגויים'));auth_error($j.(preg_match('~^ | $~',get_password())?'<br>'.'There is a space in the input password which might be the cause.':''));}if($_POST["logout"]&&$pc&&!verify_token()){page_header('התנתק','כשל באבטחת נתונים, שלח טופס שוב');page_footer("db");exit;}if($va&&$_POST["token"])$_POST["token"]=$bf;$j='';if($_POST){if(!verify_token()){$Cc="max_input_vars";$gd=ini_get($Cc);if(extension_loaded("suhosin")){foreach(array("suhosin.request.max_vars","suhosin.post.max_vars")as$w){$W=ini_get($w);if($W&&(!$gd||$W<$gd)){$Cc=$w;$gd=$W;}}}$j=(!$_POST["token"]&&$gd?sprintf('הגעת למספר השדות המרבי. בבקשה הגדל את %s',"'$Cc'"):'כשל באבטחת נתונים, שלח טופס שוב'.' '.'אם לא אתה שלחת בקשה ל-Adminer הינך יכול לסגור חלון זה');}}elseif($_SERVER["REQUEST_METHOD"]=="POST"){$j=sprintf('מידע גדול מידי נשלח ב-POST. הקטן את את המידע הוא הגדלת את הגדרות ה-%s',"'post_max_size'");if(isset($_GET["sql"]))$j.=' '.'ניתן לעלות קבצים ב-FTP ואז למשוך אותם מהשרת';}function
email_header($qc){return"=?UTF-8?B?".base64_encode($qc)."?=";}function
send_mail($zb,$He,$A,$hc="",$Sb=array()){$Eb=(DIRECTORY_SEPARATOR=="/"?"\n":"\r\n");$A=str_replace("\n",$Eb,wordwrap(str_replace("\r","","$A\n")));$Ea=uniqid("boundary");$ua="";foreach((array)$Sb["error"]as$w=>$W){if(!$W)$ua.="--$Ea$Eb"."Content-Type: ".str_replace("\n","",$Sb["type"][$w]).$Eb."Content-Disposition: attachment; filename=\"".preg_replace('~["\n]~','',$Sb["name"][$w])."\"$Eb"."Content-Transfer-Encoding: base64$Eb$Eb".chunk_split(base64_encode(file_get_contents($Sb["tmp_name"][$w])),76,$Eb).$Eb;}$Aa="";$rc="Content-Type: text/plain; charset=utf-8$Eb"."Content-Transfer-Encoding: 8bit";if($ua){$ua.="--$Ea--$Eb";$Aa="--$Ea$Eb$rc$Eb$Eb";$rc="Content-Type: multipart/mixed; boundary=\"$Ea\"";}$rc.=$Eb."MIME-Version: 1.0$Eb"."X-Mailer: Adminer Editor".($hc?$Eb."From: ".str_replace("\n","",$hc):"");return
mail($zb,email_header($He),$Aa.$A.$ua,$rc);}function
like_bool($k){return
preg_match("~bool|(tinyint|bit)\\(1\\)~",$k["full_type"]);}$f->select_db($b->database());$td="RESTRICT|NO ACTION|CASCADE|SET NULL|SET DEFAULT";$sb[DRIVER]='התחברות';if(isset($_GET["select"])&&($_POST["edit"]||$_POST["clone"])&&!$_POST["save"])$_GET["edit"]=$_GET["select"];if(isset($_GET["download"])){$a=$_GET["download"];$l=fields($a);header("Content-Type: application/octet-stream");header("Content-Disposition: attachment; filename=".friendly_url("$a-".implode("_",$_GET["where"])).".".friendly_url($_GET["field"]));$N=array(idf_escape($_GET["field"]));$J=$i->select($a,$N,array(where($_GET,$l)),$N);$L=($J?$J->fetch_row():array());echo$i->value($L[0],$l[$_GET["field"]]);exit;}elseif(isset($_GET["edit"])){$a=$_GET["edit"];$l=fields($a);$Z=(isset($_GET["select"])?($_POST["check"]&&count($_POST["check"])==1?where_check($_POST["check"][0],$l):""):where($_GET,$l));$sf=(isset($_GET["select"])?$_POST["edit"]:$Z);foreach($l
as$C=>$k){if(!isset($k["privileges"][$sf?"update":"insert"])||$b->fieldName($k)==""||$k["generated"])unset($l[$C]);}if($_POST&&!$j&&!isset($_GET["select"])){$z=$_POST["referer"];if($_POST["insert"])$z=($sf?null:$_SERVER["REQUEST_URI"]);elseif(!preg_match('~^.+&select=.+$~',$z))$z=ME."select=".urlencode($a);$u=indexes($a);$nf=unique_array($_GET["where"],$u);$Yd="\nWHERE $Z";if(isset($_POST["delete"]))queries_redirect($z,'הפריט נמחק',$i->delete($a,$Yd,!$nf));else{$P=array();foreach($l
as$C=>$k){$W=process_input($k);if($W!==false&&$W!==null)$P[idf_escape($C)]=$W;}if($sf){if(!$P)redirect($z);queries_redirect($z,'הפריט עודכן',$i->update($a,$P,$Yd,!$nf));if(is_ajax()){page_headers();page_messages($j);exit;}}else{$J=$i->insert($a,$P);$Rc=($J?last_id():0);queries_redirect($z,sprintf('הפריט %s הוזן בהצלחה',($Rc?" $Rc":"")),$J);}}}$L=null;if($_POST["save"])$L=(array)$_POST["fields"];elseif($Z){$N=array();foreach($l
as$C=>$k){if(isset($k["privileges"]["select"])){$sa=convert_field($k);if($_POST["clone"]&&$k["auto_increment"])$sa="''";if($v=="sql"&&preg_match("~enum|set~",$k["type"]))$sa="1*".idf_escape($C);$N[]=($sa?"$sa AS ":"").idf_escape($C);}}$L=array();if(!support("table"))$N=array("*");if($N){$J=$i->select($a,$N,array($Z),$N,array(),(isset($_GET["select"])?2:1));if(!$J)$j=error();else{$L=$J->fetch_assoc();if(!$L)$L=false;}if(isset($_GET["select"])&&(!$L||$J->fetch_assoc()))$L=null;}}if(!support("table")&&!$l){if(!$Z){$J=$i->select($a,array("*"),$Z,array("*"));$L=($J?$J->fetch_assoc():false);if(!$L)$L=array($i->primary=>"");}if($L){foreach($L
as$w=>$W){if(!$Z)$L[$w]=null;$l[$w]=array("field"=>$w,"null"=>($w!=$i->primary),"auto_increment"=>($w==$i->primary));}}}edit_form($a,$l,$L,$sf);}elseif(isset($_GET["select"])){$a=$_GET["select"];$T=table_status1($a);$u=indexes($a);$l=fields($a);$ec=column_foreign_keys($a);$sd=$T["Oid"];parse_str($_COOKIE["adminer_import"],$la);$je=array();$e=array();$Se=null;foreach($l
as$w=>$k){$C=$b->fieldName($k);if(isset($k["privileges"]["select"])&&$C!=""){$e[$w]=html_entity_decode(strip_tags($C),ENT_QUOTES);if(is_shortable($k))$Se=$b->selectLengthProcess();}$je+=$k["privileges"];}list($N,$p)=$b->selectColumnsProcess($e,$u);$Ic=count($p)<count($N)||strstr($N[0],"DISTINCT");$Z=$b->selectSearchProcess($l,$u);$E=$b->selectOrderProcess($l,$u);$x=$b->selectLimitProcess();if($_GET["val"]&&is_ajax()){header("Content-Type: text/plain; charset=utf-8");foreach($_GET["val"]as$of=>$L){$sa=convert_field($l[key($L)]);$N=array($sa?$sa:idf_escape(key($L)));$Z[]=where_check($of,$l);$K=$i->select($a,$N,$Z,$N);if($K)echo
reset($K->fetch_row());}exit;}$Rd=$qf=null;foreach($u
as$t){if($t["type"]=="PRIMARY"){$Rd=array_flip($t["columns"]);$qf=($N?$Rd:array());foreach($qf
as$w=>$W){if(in_array(idf_escape($w),$N))unset($qf[$w]);}break;}}if($sd&&!$Rd){$Rd=$qf=array($sd=>0);$u[]=array("type"=>"PRIMARY","columns"=>array($sd));}if($_POST&&!$j){$Ef=$Z;if(!$_POST["all"]&&is_array($_POST["check"])){$Ja=array();foreach($_POST["check"]as$Ga)$Ja[]=where_check($Ga,$l);$Ef[]="((".implode(") OR (",$Ja)."))";}$Ef=($Ef?"\nWHERE ".implode(" AND ",$Ef):"");if($_POST["export"]){cookie("adminer_import","output=".urlencode($_POST["output"])."&format=".urlencode($_POST["format"]));dump_headers($a);$b->dumpTable($a,"");$hc=($N?implode(", ",$N):"*").convert_fields($e,$l,$N)."\nFROM ".table($a);$kc=($p&&$Ic?"\nGROUP BY ".implode(", ",$p):"").($E?"\nORDER BY ".implode(", ",$E):"");if(!is_array($_POST["check"])||$Rd)$I="SELECT $hc$Ef$kc";else{$mf=array();foreach($_POST["check"]as$W)$mf[]="(SELECT".limit($hc,"\nWHERE ".($Z?implode(" AND ",$Z)." AND ":"").where_check($W,$l).$kc,1).")";$I=implode(" UNION ALL ",$mf);}$b->dumpData($a,"table",$I);exit;}if(!$b->selectEmailProcess($Z,$ec)){if($_POST["save"]||$_POST["delete"]){$J=true;$ma=0;$P=array();if(!$_POST["delete"]){foreach($e
as$C=>$W){$W=process_input($l[$C]);if($W!==null&&($_POST["clone"]||$W!==false))$P[idf_escape($C)]=($W!==false?$W:idf_escape($C));}}if($_POST["delete"]||$P){if($_POST["clone"])$I="INTO ".table($a)." (".implode(", ",array_keys($P)).")\nSELECT ".implode(", ",$P)."\nFROM ".table($a);if($_POST["all"]||($Rd&&is_array($_POST["check"]))||$Ic){$J=($_POST["delete"]?$i->delete($a,$Ef):($_POST["clone"]?queries("INSERT $I$Ef"):$i->update($a,$P,$Ef)));$ma=$f->affected_rows;}else{foreach((array)$_POST["check"]as$W){$Df="\nWHERE ".($Z?implode(" AND ",$Z)." AND ":"").where_check($W,$l);$J=($_POST["delete"]?$i->delete($a,$Df,1):($_POST["clone"]?queries("INSERT".limit1($a,$I,$Df)):$i->update($a,$P,$Df,1)));if(!$J)break;$ma+=$f->affected_rows;}}}$A=sprintf('%d פריטים הושפעו',$ma);if($_POST["clone"]&&$J&&$ma==1){$Rc=last_id();if($Rc)$A=sprintf('הפריט %s הוזן בהצלחה'," $Rc");}queries_redirect(remove_from_uri($_POST["all"]&&$_POST["delete"]?"page":""),$A,$J);if(!$_POST["delete"]){edit_form($a,$l,(array)$_POST["fields"],!$_POST["clone"]);page_footer();exit;}}elseif(!$_POST["import"]){if(!$_POST["val"])$j='לחץ ctrl + לחיצת עכבר לערוך ערך זה';else{$J=true;$ma=0;foreach($_POST["val"]as$of=>$L){$P=array();foreach($L
as$w=>$W){$w=bracket_escape($w,1);$P[idf_escape($w)]=(preg_match('~char|text~',$l[$w]["type"])||$W!=""?$b->processInput($l[$w],$W):"NULL");}$J=$i->update($a,$P," WHERE ".($Z?implode(" AND ",$Z)." AND ":"").where_check($of,$l),!$Ic&&!$Rd," ");if(!$J)break;$ma+=$f->affected_rows;}queries_redirect(remove_from_uri(),sprintf('%d פריטים הושפעו',$ma),$J);}}elseif(!is_string($Rb=get_file("csv_file",true)))$j=upload_error($Rb);elseif(!preg_match('~~u',$Rb))$j='על הקובץ להיות בקידוד utf-8';else{cookie("adminer_import","output=".urlencode($la["output"])."&format=".urlencode($_POST["separator"]));$J=true;$Ra=array_keys($l);preg_match_all('~(?>"[^"]*"|[^"\r\n]+)+~',$Rb,$cd);$ma=count($cd[0]);$i->begin();$se=($_POST["separator"]=="csv"?",":($_POST["separator"]=="tsv"?"\t":";"));$M=array();foreach($cd[0]as$w=>$W){preg_match_all("~((?>\"[^\"]*\")+|[^$se]*)$se~",$W.$se,$dd);if(!$w&&!array_diff($dd[1],$Ra)){$Ra=$dd[1];$ma--;}else{$P=array();foreach($dd[1]as$q=>$Oa)$P[idf_escape($Ra[$q])]=($Oa==""&&$l[$Ra[$q]]["null"]?"NULL":q(str_replace('""','"',preg_replace('~^"|"$~','',$Oa))));$M[]=$P;}}$J=(!$M||$i->insertUpdate($a,$M,$Rd));if($J)$J=$i->commit();queries_redirect(remove_from_uri("page"),sprintf('%d שורות יובאו',$ma),$J);$i->rollback();}}}$Me=$b->tableName($T);if(is_ajax()){page_headers();ob_start();}else
page_header('בחר'.": $Me",$j);$P=null;if(isset($je["insert"])||!support("table")){$P="";foreach((array)$_GET["where"]as$W){if($ec[$W["col"]]&&count($ec[$W["col"]])==1&&($W["op"]=="="||(!$W["op"]&&!preg_match('~[_%]~',$W["val"]))))$P.="&set".urlencode("[".bracket_escape($W["col"])."]")."=".urlencode($W["val"]);}}$b->selectLinks($T,$P);if(!$e&&support("table"))echo"<p class='error'>".'בחירת הטבלה נכשלה'.($l?".":": ".error())."\n";else{echo"<form action='' id='form'>\n","<div style='display: none;'>";hidden_fields_get();echo(DB!=""?'<input type="hidden" name="db" value="'.h(DB).'">'.(isset($_GET["ns"])?'<input type="hidden" name="ns" value="'.h($_GET["ns"]).'">':""):"");echo'<input type="hidden" name="select" value="'.h($a).'">',"</div>\n";$b->selectColumnsPrint($N,$e);$b->selectSearchPrint($Z,$e,$u);$b->selectOrderPrint($E,$e,$u);$b->selectLimitPrint($x);$b->selectLengthPrint($Se);$b->selectActionPrint($u);echo"</form>\n";$F=$_GET["page"];if($F=="last"){$gc=$f->result(count_rows($a,$Z,$Ic,$p));$F=floor(max(0,$gc-1)/$x);}$ne=$N;$jc=$p;if(!$ne){$ne[]="*";$bb=convert_fields($e,$l,$N);if($bb)$ne[]=substr($bb,2);}foreach($N
as$w=>$W){$k=$l[idf_unescape($W)];if($k&&($sa=convert_field($k)))$ne[$w]="$sa AS $W";}if(!$Ic&&$qf){foreach($qf
as$w=>$W){$ne[]=idf_escape($w);if($jc)$jc[]=idf_escape($w);}}$J=$i->select($a,$ne,$Z,$jc,$E,$x,$F,true);if(!$J)echo"<p class='error'>".error()."\n";else{if($v=="mssql"&&$F)$J->seek($x*$F);$Ab=array();echo"<form action='' method='post' enctype='multipart/form-data'>\n";$M=array();while($L=$J->fetch_assoc()){if($F&&$v=="oracle")unset($L["RNUM"]);$M[]=$L;}if($_GET["page"]!="last"&&$x!=""&&$p&&$Ic&&$v=="sql")$gc=$f->result(" SELECT FOUND_ROWS()");if(!$M)echo"<p class='message'>".'אין שורות'."\n";else{$_a=$b->backwardKeys($a,$Me);echo"<div class='scrollable'>","<table id='table' cellspacing='0' class='nowrap checkable'>",script("mixin(qs('#table'), {onclick: tableClick, ondblclick: partialArg(tableClick, true), onkeydown: editingKeydown});"),"<thead><tr>".(!$p&&$N?"":"<td><input type='checkbox' id='all-page' class='jsonly'>".script("qs('#all-page').onclick = partial(formCheck, /check/);","")." <a href='".h($_GET["modify"]?remove_from_uri("modify"):$_SERVER["REQUEST_URI"]."&modify=1")."' title='".'ערוך'."' class='edit-all'>".'ערוך'."</a>");$md=array();$ic=array();reset($N);$ae=1;foreach($M[0]as$w=>$W){if(!isset($qf[$w])){$W=$_GET["columns"][key($N)];$k=$l[$N?($W?$W["col"]:current($N)):$w];$C=($k?$b->fieldName($k,$ae):($W["fun"]?"*":$w));if($C!=""){$ae++;$md[$w]=$C;$d=idf_escape($w);$vc=remove_from_uri('(order|desc)[^=]*|page').'&order%5B0%5D='.urlencode($w);$mb="&desc%5B0%5D=1";echo"<th id='th[".h(bracket_escape($w))."]'>".script("mixin(qsl('th'), {onmouseover: partial(columnMouse), onmouseout: partial(columnMouse, ' hidden')});",""),'<a href="'.h($vc.($E[0]==$d||$E[0]==$w||(!$E&&$Ic&&$p[0]==$d)?$mb:'')).'">';echo
apply_sql_function($W["fun"],$C)."</a>";echo"<span class='column hidden'>","<a href='".h($vc.$mb)."' title='".'סדר הפוך'."' class='text'> ↓</a>";if(!$W["fun"]){echo'<a href="#fieldset-search" title="'.'חפש'.'" class="text jsonly"> =</a>',script("qsl('a').onclick = partial(selectSearch, '".js_escape($w)."');");}echo"</span>";}$ic[$w]=$W["fun"];next($N);}}$Uc=array();if($_GET["modify"]){foreach($M
as$L){foreach($L
as$w=>$W)$Uc[$w]=max($Uc[$w],min(40,strlen(utf8_decode($W))));}}echo($_a?"<th>".'הקשרים':"")."</thead>\n";if(is_ajax()){if($x%2==1&&$F%2==1)odd();ob_end_clean();}foreach($b->rowDescriptions($M,$ec)as$B=>$L){$nf=unique_array($M[$B],$u);if(!$nf){$nf=array();foreach($M[$B]as$w=>$W){if(!preg_match('~^(COUNT\((\*|(DISTINCT )?`(?:[^`]|``)+`)\)|(AVG|GROUP_CONCAT|MAX|MIN|SUM)\(`(?:[^`]|``)+`\))$~',$w))$nf[$w]=$W;}}$of="";foreach($nf
as$w=>$W){if(($v=="sql"||$v=="pgsql")&&preg_match('~char|text|enum|set~',$l[$w]["type"])&&strlen($W)>64){$w=(strpos($w,'(')?$w:idf_escape($w));$w="MD5(".($v!='sql'||preg_match("~^utf8~",$l[$w]["collation"])?$w:"CONVERT($w USING ".charset($f).")").")";$W=md5($W);}$of.="&".($W!==null?urlencode("where[".bracket_escape($w)."]")."=".urlencode($W===false?"f":$W):"null%5B%5D=".urlencode($w));}echo"<tr".odd().">".(!$p&&$N?"":"<td>".checkbox("check[]",substr($of,1),in_array(substr($of,1),(array)$_POST["check"])).($Ic||information_schema(DB)?"":" <a href='".h(ME."edit=".urlencode($a).$of)."' class='edit' title='".'ערוך'."'>".'ערוך'."</a>"));foreach($L
as$w=>$W){if(isset($md[$w])){$k=$l[$w];$W=$i->value($W,$k);if($W!=""&&(!isset($Ab[$w])||$Ab[$w]!=""))$Ab[$w]=(is_mail($W)?$md[$w]:"");$y="";if(preg_match('~blob|bytea|raw|file~',$k["type"])&&$W!="")$y=ME.'download='.urlencode($a).'&field='.urlencode($w).$of;if(!$y&&$W!==null){foreach((array)$ec[$w]as$dc){if(count($ec[$w])==1||end($dc["source"])==$w){$y="";foreach($dc["source"]as$q=>$Ae)$y.=where_link($q,$dc["target"][$q],$M[$B][$Ae]);$y=($dc["db"]!=""?preg_replace('~([?&]db=)[^&]+~','\1'.urlencode($dc["db"]),ME):ME).'select='.urlencode($dc["table"]).$y;if($dc["ns"])$y=preg_replace('~([?&]ns=)[^&]+~','\1'.urlencode($dc["ns"]),$y);if(count($dc["source"])==1)break;}}}if($w=="COUNT(*)"){$y=ME."select=".urlencode($a);$q=0;foreach((array)$_GET["where"]as$V){if(!array_key_exists($V["col"],$nf))$y.=where_link($q++,$V["col"],$V["val"],$V["op"]);}foreach($nf
as$Kc=>$V)$y.=where_link($q++,$Kc,$V);}$W=select_value($W,$y,$k,$Se);$r=h("val[$of][".bracket_escape($w)."]");$X=$_POST["val"][$of][bracket_escape($w)];$xb=!is_array($L[$w])&&is_utf8($W)&&$M[$B][$w]==$L[$w]&&!$ic[$w];$Re=preg_match('~text|lob~',$k["type"]);echo"<td id='$r'";if(($_GET["modify"]&&$xb)||$X!==null){$mc=h($X!==null?$X:$L[$w]);echo">".($Re?"<textarea name='$r' cols='30' rows='".(substr_count($L[$w],"\n")+1)."'>$mc</textarea>":"<input name='$r' value='$mc' size='$Uc[$w]'>");}else{$Zc=strpos($W,"<i>…</i>");echo" data-text='".($Zc?2:($Re?1:0))."'".($xb?"":" data-warning='".h('השתמש בקישור העריכה בשביל לשנות את הערך')."'").">$W</td>";}}}if($_a)echo"<td>";$b->backwardKeysPrint($_a,$M[$B]);echo"</tr>\n";}if(is_ajax())exit;echo"</table>\n","</div>\n";}if(!is_ajax()){if($M||$F){$Jb=true;if($_GET["page"]!="last"){if($x==""||(count($M)<$x&&($M||!$F)))$gc=($F?$F*$x:0)+count($M);elseif($v!="sql"||!$Ic){$gc=($Ic?false:found_rows($T,$Z));if($gc<max(1e4,2*($F+1)*$x))$gc=reset(slow_query(count_rows($a,$Z,$Ic,$p)));else$Jb=false;}}$Ed=($x!=""&&($gc===false||$gc>$x||$F));if($Ed){echo(($gc===false?count($M)+1:$gc-$F*$x)>$x?'<p><a href="'.h(remove_from_uri("page")."&page=".($F+1)).'" class="loadmore">'.'טען נתונים נוספים'.'</a>'.script("qsl('a').onclick = partial(selectLoadMore, ".(+$x).", '".'טוען'."…');",""):''),"\n";}}echo"<div class='footer'><div>\n";if($M||$F){if($Ed){$ed=($gc===false?$F+(count($M)>=$x?2:1):floor(($gc-1)/$x));echo"<fieldset>";if($v!="simpledb"){echo"<legend><a href='".h(remove_from_uri("page"))."'>".'עמוד'."</a></legend>",script("qsl('a').onclick = function () { pageClick(this.href, +prompt('".'עמוד'."', '".($F+1)."')); return false; };"),pagination(0,$F).($F>5?" …":"");for($q=max(1,$F-4);$q<min($ed,$F+5);$q++)echo
pagination($q,$F);if($ed>0){echo($F+5<$ed?" …":""),($Jb&&$gc!==false?pagination($ed,$F):" <a href='".h(remove_from_uri("page")."&page=last")."' title='~$ed'>".'אחרון'."</a>");}}else{echo"<legend>".'עמוד'."</legend>",pagination(0,$F).($F>1?" …":""),($F?pagination($F,$F):""),($ed>$F?pagination($F+1,$F).($ed>$F+1?" …":""):"");}echo"</fieldset>\n";}echo"<fieldset>","<legend>".'כל התוצאות'."</legend>";$qb=($Jb?"":"~ ").$gc;echo
checkbox("all",1,0,($gc!==false?($Jb?"":"~ ").sprintf('%d שורות',$gc):""),"var checked = formChecked(this, /check/); selectCount('selected', this.checked ? '$qb' : checked); selectCount('selected2', this.checked || !checked ? '$qb' : checked);")."\n","</fieldset>\n";if($b->selectCommandPrint()){echo'<fieldset',($_GET["modify"]?'':' class="jsonly"'),'><legend>ערוך</legend><div>
<input type="submit" value="שמור"',($_GET["modify"]?'':' title="'.'לחץ ctrl + לחיצת עכבר לערוך ערך זה'.'"'),'>
</div></fieldset>
<fieldset><legend>נבחרים <span id="selected"></span></legend><div>
<input type="submit" name="edit" value="ערוך">
<input type="submit" name="clone" value="שכפל">
<input type="submit" name="delete" value="מחק">',confirm(),'</div></fieldset>
';}$fc=$b->dumpFormat();foreach((array)$_GET["columns"]as$d){if($d["fun"]){unset($fc['sql']);break;}}if($fc){print_fieldset("export",'יצא'." <span id='selected2'></span>");$Cd=$b->dumpOutput();echo($Cd?html_select("output",$Cd,$la["output"])." ":""),html_select("format",$fc,$la["format"])," <input type='submit' name='export' value='".'יצא'."'>\n","</div></fieldset>\n";}$b->selectEmailPrint(array_filter($Ab,'strlen'),$e);}echo"</div></div>\n";if($b->selectImportPrint()){echo"<div>","<a href='#import'>".'יבא'."</a>",script("qsl('a').onclick = partial(toggle, 'import');",""),"<span id='import' class='hidden'>: ","<input type='file' name='csv_file'> ",html_select("separator",array("csv"=>"CSV,","csv;"=>"CSV;","tsv"=>"TSV"),$la["format"],1);echo" <input type='submit' name='import' value='".'יבא'."'>","</span>","</div>";}echo"<input type='hidden' name='token' value='$bf'>\n","</form>\n",(!$p&&$N?"":script("tableCheck();"));}}}if(is_ajax()){ob_end_clean();exit;}}elseif(isset($_GET["script"])){if($_GET["script"]=="kill")$f->query("KILL ".number($_POST["kill"]));elseif(list($S,$r,$C)=$b->_foreignColumn(column_foreign_keys($_GET["source"]),$_GET["field"])){$x=11;$J=$f->query("SELECT $r, $C FROM ".table($S)." WHERE ".(preg_match('~^[0-9]+$~',$_GET["value"])?"$r = $_GET[value] OR ":"")."$C LIKE ".q("$_GET[value]%")." ORDER BY 2 LIMIT $x");for($q=1;($L=$J->fetch_row())&&$q<$x;$q++)echo"<a href='".h(ME."edit=".urlencode($S)."&where".urlencode("[".bracket_escape(idf_unescape($r))."]")."=".urlencode($L[0]))."'>".h($L[1])."</a><br>\n";if($L)echo"...\n";}exit;}else{page_header('שרת',"",false);if($b->homepage()){echo"<form action='' method='post'>\n","<p>".'חפש מידע בטבלאות'.": <input type='search' name='query' value='".h($_POST["query"])."'> <input type='submit' value='".'חפש'."'>\n";if($_POST["query"]!="")search_tables();echo"<div class='scrollable'>\n","<table cellspacing='0' class='nowrap checkable'>\n",script("mixin(qsl('table'), {onclick: tableClick, ondblclick: partialArg(tableClick, true)});"),'<thead><tr class="wrap">','<td><input id="check-all" type="checkbox" class="jsonly">'.script("qs('#check-all').onclick = partial(formCheck, /^tables\[/);",""),'<th>'.'טבלה','<td>'.'שורות',"</thead>\n";foreach(table_status()as$S=>$L){$C=$b->tableName($L);if(isset($L["Engine"])&&$C!=""){echo'<tr'.odd().'><td>'.checkbox("tables[]",$S,in_array($S,(array)$_POST["tables"],true)),"<th><a href='".h(ME).'select='.urlencode($S)."'>$C</a>";$W=format_number($L["Rows"]);echo"<td align='right'><a href='".h(ME."edit=").urlencode($S)."'>".($L["Engine"]=="InnoDB"&&$W?"~ $W":$W)."</a>";}}echo"</table>\n","</div>\n","</form>\n",script("tableCheck();");}}page_footer();